///////////////////////////////////////////////////////////////////////////////
//
//				Coverter Utf8 <--> cp1250
//					    &
//				 Filter filenames names
//
//					(LIBBRARY)
//
//					 ver 0.1
//				       (JPW 2018)
//
//    Converter:
//         changes coding from the table of utf-8 to the table of cp1250 
//         and from the table of cp1250 (Windows) to the table of utf-8
//    moreover:
//         changes in the string filename diacritics into an appropriate chars 
//	   form the ASCII table and filters other chars changing into "_",
//	   except "-" (minus), "." (dot) and "_".
//         
//
///////////////////////////////////////////////////////////////////////////////




#include <stdio.h>
#include <string.h>
#include <stdlib.h>
//#include <locale.h>



////////////////////////////////// TABLES /////////////////////////////////////
char w1250[127] = 	{
						0x80, 0x82, 0x84, 0x85, 0x86, 0x87, 0x89, 0x8A, 0x8B, 0x8C,
 						0x8D, 0x8E, 0x8F, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97,
			 			0x99, 0x9A, 0x9B, 0x9C, 0x9D, 0x9E, 0x9F, 0xA2, 0xA3, 0xA4,
						0xA5, 0xA6, 0xA7, 0xA8, 0xA9, 0xAA, 0xAB, 0xAC, 0xAD, 0xAE,
						0xAF, 0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6, 0xB7, 0xB8,
						0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0xBE, 0xBF, 0xC0, 0xC1, 0xC2,
						0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC,
						0xCD, 0xCE, 0xCF, 0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6,
						0xD7, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0xDF, 0xE0,
						0xE1, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6, 0xE7, 0xE8, 0xE9, 0xEA,
						0xEB, 0xEC, 0xED, 0xEE, 0xEF, 0xF0, 0xF1, 0xF2, 0xF3, 0xF4,
						0xF5, 0xF6, 0xF7, 0xF8, 0xF9, 0xFA, 0xFB, 0xFC, 0xFD, 0xFE,
						0xFF};
						
				
char utf_0[127] =	{
						0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc5,
						0xc5, 0xc2, 0xc5, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2,
						0xc2, 0xc2, 0xc2, 0xc5, 0xc2, 0xc2, 0xc5, 0xcb, 0xc5, 0xc2,
						0xc4, 0xc2, 0xc2, 0xc2, 0xc2, 0xc5, 0xc2, 0xc2, 0xc2, 0xc2,
						0xc5, 0xc2, 0xc2, 0xc2, 0xc5, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2,
						0xc4, 0xc5, 0xc2, 0xc4, 0xcb, 0xc4, 0xc5, 0xc5, 0xc3, 0xc3,
						0xc4, 0xC3, 0xc4, 0xc4, 0xc3, 0xc4, 0xc3, 0xc4, 0xc3, 0xc4,
						0xc3, 0xc3, 0xc4, 0xc3, 0xc5, 0xc5, 0xc3, 0xc3, 0xc5, 0xC3,
						0xc3, 0xc5, 0xc5, 0xc3, 0xc5, 0xC3, 0xc3, 0xc5, 0xC3, 0xc5,
						0xc3, 0xc3, 0xc4, 0xC3, 0xc4, 0xc4, 0xc3, 0xc4, 0xc4, 0xc4,
						0xc3, 0xc4, 0xc3, 0xc3, 0xc4, 0xc4, 0xc5, 0xc5, 0xc3, 0xc3,
						0xc5, 0xC3, 0xc3, 0xc5, 0xc5, 0xc3, 0xc5, 0xC3, 0xc3, 0xc5,
						0xcb};
						
				
char utf_1[127] = 	{
						0x80, 0x82, 0x84, 0x85, 0x86, 0x87, 0x89, 0x8a, 0x8b, 0x9a,
						0xa4, 0x9e, 0xb9, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97,
						0x99, 0x9a, 0x9b, 0x9b, 0x9d, 0x9e, 0xba, 0x98, 0x81, 0xa4,
						0x84, 0xa6, 0xa7, 0xa8, 0xa9, 0x9e, 0xab, 0xac, 0xad, 0xae,
						0xbb, 0xb0, 0xb1, 0xb2, 0x82, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8,
						0x85, 0x9f, 0xbb, 0xb9, 0x9c, 0xba, 0xbc, 0x94, 0x81, 0x82,
						0x82, 0x84, 0xb9, 0x86, 0x87, 0x8c, 0x89, 0x98, 0x8b, 0x94,
						0x8d, 0x8e, 0x8e, 0x90, 0x83, 0x87, 0x93, 0x94, 0x90, 0x96,
						0x97, 0x98, 0xae, 0x9a, 0xb0, 0x9C, 0x9d, 0xa6, 0x9F, 0x95,
						0xa1, 0xa2, 0x83, 0xA4, 0xba, 0x87, 0xa7, 0x8d, 0x97, 0x99,
						0xab, 0x9b, 0xad, 0xae, 0x8f, 0x91, 0x84, 0x88, 0xb3, 0xb4,
						0x91, 0xB6, 0xb7, 0x99, 0xaf, 0xba, 0xb1, 0xBC, 0xbd, 0xa3,
						0x99};
				
				
char filter_w1250[90] = {
						0x8A, 0x8C, 0x8D, 0x8E, 0x8F, 0x9A, 0x9C, 0x9D, 0x9E, 0x9F,
 						0xA3, 0xA5, 0xAA, 0xAF, 0xB3, 0xB5, 0xB6, 0xB9, 0xBA, 0xBC,
 						0xBE, 0xBF, 0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7,
 						0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0, 0xD1,
 						0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC,
 						0xDD, 0xDE, 0xDF, 0xE0, 0xE1, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6,
 						0xE7, 0xE8, 0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF, 0xF0,
 						0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF8, 0xF9, 0xFA, 0xFB,
 						0xFC, 0xFD, 0xFE};
 						
							
char filter_utf_0[90] = {
						0xc2, 0xc5, 0xc5, 0xc2, 0xc5, 0xc2, 0xc5, 0xc2, 0xc2, 0xc5,
						0xc5, 0xc4, 0xc5, 0xc5, 0xc5, 0xc2, 0xc2, 0xc4, 0xc5, 0xc4,
						0xc4, 0xc5, 0xc5, 0xc3, 0xc3, 0xc4, 0xC3, 0xc4, 0xc4, 0xc3,
						0xc4, 0xc3, 0xc4, 0xc3, 0xc4, 0xc3, 0xc3, 0xc4, 0xc3, 0xc5,
						0xc5, 0xc3, 0xc3, 0xc5, 0xC3, 0xc5, 0xc5, 0xc3, 0xc5, 0xC3,
						0xc3, 0xc5, 0xC3, 0xc5, 0xc3, 0xc3, 0xc4, 0xC3, 0xc4, 0xc4,
						0xc3, 0xc4, 0xc4, 0xc4, 0xc3, 0xc4, 0xc3, 0xc3, 0xc4, 0xc4,
						0xc5, 0xc5, 0xc3, 0xc3, 0xc5, 0xC3, 0xc5, 0xc5, 0xc3, 0xc5,
						0xC3, 0xc3, 0xc5};	
														

char filter_utf_1[90] = {
						0x8a, 0x9a, 0xa4, 0x9e, 0xb9, 0x9a, 0x9b, 0x9d, 0x9e, 0xba,
						0x81, 0x84, 0x9e, 0xbb, 0x82, 0xb5, 0xb6, 0x85, 0x9f, 0xb9,
						0xba, 0xbc, 0x94, 0x81, 0x82, 0x82, 0x84, 0xb9, 0x86, 0x87,
						0x8c, 0x89, 0x98, 0x8b, 0x94, 0x8d, 0x8e, 0x8e, 0x90, 0x83,
						0x87, 0x93, 0x94, 0x90, 0x96, 0x98, 0xae, 0x9a, 0xb0, 0x9C,
						0x9d, 0xa6, 0x9F, 0x95, 0xa1, 0xa2, 0x83, 0xA4, 0xba, 0x87,
						0xa7, 0x8d, 0x97, 0x99, 0xab, 0x9b, 0xad, 0xae, 0x8f, 0x91,
						0x84, 0x88, 0xb3, 0xb4, 0x91, 0xB6, 0x99, 0xaf, 0xba, 0xb1,
						 0xBC, 0xbd, 0xa3};
						 

char filter_ascii[90] = {
						0x53, 0x53, 0x54, 0x5A, 0x5A, 0x73, 0x73, 0x74, 0x7A, 0x7A,
						0x4C, 0x41, 0x53, 0x5A, 0x6C, 0x6D, 0x70, 0x61, 0x73, 0x4C,
						0x6C, 0x7A, 0x52, 0x41, 0x41, 0x41, 0x41, 0x4C, 0x43, 0x43,
						0x43, 0x45, 0x45, 0x45, 0x45, 0x49, 0x49, 0x44, 0x44, 0x4E,
						0x4E, 0x4F, 0x4F, 0x4F, 0x4F, 0x52, 0x55, 0x55, 0x55, 0x55,
						0x59, 0x54, 0x53, 0x72, 0x61, 0x61, 0x61, 0x61, 0x6C, 0x63,
						0x63, 0x63, 0x65, 0x65, 0x65, 0x65, 0x69, 0x69, 0x64, 0x64,
						0x6E, 0x6E, 0x6F, 0x6F, 0x6F, 0x6F, 0x72, 0x75, 0x75, 0x75,
						0x75, 0x79, 0x74};

/////////////////////////////// END TABLES ////////////////////////////////////


	
///////////////////////////////////////////////////////////////////////////////
////////////////////////////////// CENVERTERS /////////////////////////////////
///////////////////////////////////////////////////////////////////////////////	
//converting utf8 into cp1250
// input:
//		in 			- string on input coded in utf format
//		len_in 		- lenght of string on input (usually: strlen(in) if on the end is '\0'
// Output:
//		out			- returns string in cp1250 coding
//		len_out		- lenght of string out with '\0' on the end 
void conv_utf8_to_cp1250(const char*in, int len_in, char*out, int*len_out) {
		
		int i, j, ch, len;
		
		len = 0;	
		
		for(i=0; i<len_in; i++) {
			
	        ch = 1;
	        
	        j = 0;
	        
			while( j < 121 && ch == 1) {
					
				if( *(in+i) == *(utf_0+j) && *(in+i+1) == *(utf_1+j) ) {
						
					*(out + len) = *(w1250+j);
					len++;
					ch = 0;
					i++;
				}
				
				j++;
			}		

			if( ch == 1 )  {
				*(out+len) = *(in+i); //if ASCII 
				len ++;
			} 
		}
		
		*(out+len) = '\0';
		*len_out = len; 

}
	
	
//converting cp1250 into utf8
// input:
//		in 			- string on input coded in utf format
//		len_in 		- lenght of string on input (usually: strlen(in) if on the end is '\0'
//Output:
//		out			- returns string in cp1250 coding
//		len_out		- lenght of string out with '\0' on the end
void conv_cp1250_to_utf8(const char*in, int len_in, char*out, int*len_out) {
		
		int i, j, ch, 
	
		len = 0;
				
		for(i=0; i<len_in; i++) {
			
				ch = 1;
				
				j = 0;
				
				while(j < 121 && ch == 1) {

					if (*(in+i) == *(w1250+j)) {
						*(out + len) = *(utf_0 + j);
						len ++;
						*(out + len) = *(utf_1 + j);
						len ++;	
						ch = 0;
											
					}
					
					j++; 
				}
				
			if(ch == 1) { 
				*(out+len) = *(in+i); //if ASCII	
				len++;
			}
			
		}
		
		*(out + len) = '\0';
		*len_out = len; 
}
/////////////////////////////// END CONVERTERS ////////////////////////////////	
	


///////////////////////////////////////////////////////////////////////////////
/////////////////////////////////// FILTERS ///////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//Filter for utf8 --> to ASCII
// input:
//		in - string coded in utf8
//		len_in - tnegth of in string (must be ended by '\0'
// Output:
//		out - ooutput string after filtering 
void filter_utf8_to_ascii(const char*in, int len_in, char*out) {
	
	int i, j, k, ch;
	
	k = 0;
	
	for(i=0; i<len_in; i++) {
		
		ch = 1;
		j = 0;

		while(j < 83 && ch == 1) {
			//changes utf8 char into ascii char 
			if( *(in+i) == *(filter_utf_0+j) && *(in+i+1) == *(filter_utf_1+j) ) {
	
				*(out+k) = *(filter_ascii+j);
				k++;
				ch = 0;
				i++;
			}
			
			j++;
		}

		if(ch == 1) {
				
			//if ascii
			*(out+k) = *(in+i);	
					
			//only numbers and alphanumeric char
			if( *(out+k) < 45)  *(out+k) = '_';
			if( *(out+k) > 46 && *(out+k) < 48 ) *(out+k) = '_';
			if( *(out+k) > 57 && *(out+k) < 65 ) *(out+k) = '_';
			if( *(out+k) > 90 && *(out+k) < 97 ) *(out+k) = '_';
			if( *(out+k) > 122 && *(out+k) < 128) *(out+k) = '_';
			if( *(out+k) < 128) k++;
		
			}
	
	}
	
	*(out+k) = '\0';
}


//Filter for cp1250 --> to ASCI
// input:
//		in - string coded in utf8
//		len_in - tnegth of in string (must be ended by '\0'
// Output:
//		out - ooutput string after filtering
void filter_w1250_to_ascii(const char*in, int len_in, char*out) {

	int i, j, k, ch;
	
	k = 0;
	
	for(i=0; i<len_in; i++) {
		
		ch = 1;
		j = 0; 
		
		while(j < 83 && ch == 1) {

			//changes utf8 char into ascii char 
			if( *(in+i) == *(filter_w1250+j) ) {
		
				*(out+k) = *(filter_ascii+j);
				k++;
			    ch = 0;
				
			} 
			
        	j++;
		}			
		if(ch == 1) {
				
			//if ascii
				*(out+k) = *(in+i);	
				
			//only numbers and alphanumeric chars
			if( *(out+k) < 45)  *(out+k) = '_';
			if( *(out+k) > 46 && *(out+k) < 48 ) *(out+k) = '_';
			if( *(out+k) > 57 && *(out+k) < 65 ) *(out+k) = '_';
			if( *(out+k) > 90 && *(out+k) < 97 ) *(out+k) = '_';
			if( *(out+k) > 122 ) *(out+k) = '_';
			k++;		
		} 
				
	}
	*(out+k) = '\0';
}	
///////////////////////////////// END FILTERS /////////////////////////////////	
