///////////////////////////////////////////////////////////////////////////////
//
//			                       CheckAdmin UIDC
//		                             (Library)
//			                     on Leszifr ver. 0.3
//			                         (JPW 2019)
//	
///////////////////////////////////////////////////////////////////////////////



#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "LESZIFR/leszifr3.h"


#define FILE_KEY_NAME "registration-key"




//internaal select value
int select_value_(const char*input, const char*keystr, char*output) {
	char *i;
	int k=0;;
	char*key = (char*)malloc((strlen(keystr)+1)*sizeof(char));
	strcpy(key,keystr);strcat(key,"=");
	if(strlen(input)<4) {free(key);return -1; }
	char*t = strstr(input,key);
	if(t==NULL) {strcpy(output,"NULL"); free(key);return -1;}
	char*s1 = strchr(t,'=');
	char*s2 = strchr(t,'&');
	if(s1==NULL) {strcpy(output,"NULL");free(key);return -1;}
	if(s2==NULL) {strcpy(output,"NULL");free(key);return -1;}
	for(i=s1+1;i<s2;i++) {output[k]=*i;k++;}
	output[k]='\0';
	free(key);
	return 0;
}





//sprawdza admina
int check_admin_UIDC(const char*nick, char*pesel) {

char* zen  =  "zenity --password --width=300 --title='ADMIN UIDC PASSWORD' --text 'Enter password' 2>/dev/null";

char*err  = "zenity --error --width=300 --text 'Damaged registration-key' 2>/dev/null";

char*info = "zenity --info --width=200 --text 'Incorrect password!' 2>/dev/null";


	struct stat sb;

	int i;
	char pad[4096];
	char passwd[80] = "null";
	char str[256];
	char b_name[80];
	char b_passwd[80];
	char*p;


	//pyta o password UIDC admin
	FILE*fp = popen(zen, "r");
	if(fp == NULL)  return -1;
	fgets(passwd, 15, fp);
	pclose(fp);
	p = strchr(passwd, '\n');
	if(p != NULL) *p = '\0';
 	if(strcmp(passwd, "null") == 0) return -1; //klawisz CANCEL


	strcpy(str, "USERS-KEYS/");
	strcat(str, nick);
	strcat(str, "/");
	strcat(str, FILE_KEY_NAME);
	strcat(str, ".archi");

	//jesli brak registration-key.archi w katalogu
	if(stat(str, &sb) < 0) return -1;

	//deszyfruje registration-key.archi
	if(leszifr3decode(str, passwd, 1) < 0) {
		fp = popen(info, "r");
		if(fp != NULL) pclose(fp);
		return -1;
	}

	strcpy(str, "USERS-KEYS/");
	strcat(str, nick);
	strcat(str, "/");
	strcat(str, FILE_KEY_NAME);

	fp = fopen(str, "r");
	if(fp == NULL) return -1;

	fread(pad, 4096, 1, fp);

	//zamyka i usuwa plik
	fclose(fp);
	remove(str);
	
	//sprawdza czy plik nie jest uszkodzony
	p = strchr(pad, '\0');
	if(p == NULL) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		return -1;
	}

	memcpy(str, &pad[0], p-&pad[0]);
	
	i = 0;
	select_value_(str, "NAME", b_name);
	if(strcmp(b_name, "NULL") == 0) i = 1;
	select_value_(str, "PESEL", pesel);
	if(strcmp(pesel, "NULL") == 0) i = 1;
	select_value_(str, "PASSWD", b_passwd);
	if(strcmp(b_passwd, "NULL") == 0) i = 1;

	if(i) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		return -1;
	}

	i = 0;
	if(strcmp(b_name, nick) != 0) i = 1;
	if(strcmp(b_passwd, passwd) != 0) i = 1;

	if(i) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		return -1;
	}

	return 0;
}


int write_tmp(const char*str) {
	FILE*fd = fopen("tmp.q", "w");
	if(fd == NULL) return -1;
	fprintf(fd, "%s\n", str);
	fclose(fd);
	return 0;
}


//argv[0] - this aplication
//argv[1] - descriptor "CH201908DD30"
//argv[2] - nick/name
//return PESEL or "PESEL=null&" if error


int main(int argc, char**argv) {

	char pesel[80];
	char str[80];


	if(argc == 3) {

		if(strcmp(argv[1], "CH201908DD30") != 0) {
			write_tmp("PESEL=null&");
			return 0;
		}

		if(check_admin_UIDC(argv[2], pesel) < 0) {
			write_tmp("PESEL=null&");
			return 0;
		} 

		strcpy(str, "PESEL=");
		strcat(str, pesel);
		strcat(str, "&");
		write_tmp(str);
		return 0;
	}

	write_tmp("PESEL=null&");

	return 0;
}


