///////////////////////////////////////////////////////////////////////////////
//
//			   Register Admin UIDC
//		                (Library)
//			   on Leszifr ver. 0.3
//			       (JPW 2019)
//	
///////////////////////////////////////////////////////////////////////////////



#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
 #include <sys/types.h>
#include "LESZIFR/leszifr3.h"


#define FILE_KEY_NAME "registration-key"






///////////////////////////////////////////////////////////////////////////////
//----------------------- SPRAWDZANIE FORMUL PESEL ----------------------------
///////////////////////////////////////////////////////////////////////////////
//sprawdza formule pesel/nip/regon
int check_form_pesel(const char*pesel) {

	int sum;
	int i;

//printf("NIP: %s\n", pesel);

	if(strlen(pesel) != 11) return 0; //za krotki lub za dlugi PESEL
	if(strcmp(pesel, "N0000000000") == 0) return 0; //odrzucony NIP

	//selekcja pesel, nip, regon, konto specjalne
	if(pesel[0] == 'N') goto label_nip;
	if(pesel[0] == 'R' && pesel[1] == 'N') goto label_regon;
	if(pesel[0] == 'R' && pesel[1] == 'S') goto label_specjal;

	//sprawdza wytepowanie cyfr w stringu pesel
	for(i=0; i<11; i++) {
	   if( *(pesel+i)<'0' && *(pesel+i)>'9') return 0;
	}
	
	//sprawdza formule pesel
	//9×a + 7×b + 3×c + 1×d + 9×e + 7×f + 3×g + 1×h + 9×i + 7×j
	sum = 	9*(pesel[0] - 48) +
		7*(pesel[1] - 48) +
		3*(pesel[2] - 48) +
		1*(pesel[3] - 48) +
		9*(pesel[4] - 48) +
		7*(pesel[5] - 48) +
		3*(pesel[6] - 48) +
		1*(pesel[7] - 48) +
		9*(pesel[8] - 48) +
		7*(pesel[9] - 48);
	//oblicza reszte
	sum %= 10;

	//sprawdza reszte z ostania cyfra
	if(sum == pesel[10]-48) return 1;
	else return 0;

label_nip:
//puts("---nip");
	//sprawdza cyfry w stringu pesel
	for(i=1; i<11; i++) {
	   if( *(pesel+i)<'0' && *(pesel+i)>'9') return 0;
	}

	//sprawdza formule nip
	//wagi 6, 5, 7, 2, 3, 4, 5, 6, 7
	sum =	6*(pesel[1] - 48) +
		5*(pesel[2] - 48) +
		7*(pesel[3] - 48) +
		2*(pesel[4] - 48) +
		3*(pesel[5] - 48) +
		4*(pesel[6] - 48) +
		5*(pesel[7] - 48) +
		6*(pesel[8] - 48) +
		7*(pesel[9] - 48);
	//oblicza reszte
	sum %= 11;
//printf("SUM: %d\n", sum);
	if(sum == pesel[10]-48) return 1;
	else return 0;
	

label_regon:

	//sprawdza cyfry w stringu pesel
	for(i=2; i<11; i++) {
	   if( *(pesel+i)<'0' && *(pesel+i)>'9') return 0;
	}

	//sprawdza formule regon
	//wagi: 8, 9, 2, 3, 4, 5, 6, 7
	sum = 	8*(pesel[2] - 48) +
		9*(pesel[3] - 48) +
		2*(pesel[4] - 48) +
		3*(pesel[5] - 48) +
		4*(pesel[6] - 48) +
		5*(pesel[7] - 48) +
		6*(pesel[8] - 48) +
		7*(pesel[9] - 48);
	//oblicza reszte
	sum %= 11;
	if(sum == 10) sum = 0;
	if(sum == pesel[10]-48) return 1;
	else return 0;


label_specjal:

	//sprawdza cyfry w stringu specjalnym
	sum = 1;
	for(i=2; i<11; i++) {
	   if( *(pesel+i)<'0' && *(pesel+i)>'9') sum = 0;
	}
	if(sum) return 1;

	return 0;
}
///////////////////////////////////////////////////////////////////////////////
//--------------------- END SPRAWDZANIE FORMUL PESEL --------------------------
///////////////////////////////////////////////////////////////////////////////



















//OP=log_adm&PESEL=...&NICK=..& - zapis do pliku logowania w CENTRAL SERVER
void make_registertation_key(void) {

char*zen =  "zenity --forms --title='REGISTRATION UIDC ADMIN' --text='Enter Admin Data' --separator='|' --add-entry='Name/Nick Admin' --add-password='Enter password' --add-password='Repeat password' 2>/dev/null";

char*psl = "zenity --entry --width=300 --title='Enter New Admin PESEL' --text='Enter PESEL (11 digits)' 2>/dev/null";
char*psl_err = "zenity --error --width=200 --text 'Wrong PESEL form!' 2>/dev/null";

char*err  = "zenity --error --width=300 --text 'The repeated passwd is different!' 2>/dev/null";
char*err1  = "zenity --error --width=300 --text 'Password must have at least 4 chars!' 2>/dev/null";
char*err2  = "zenity --error --width=300 --text 'Cannot make registration key!' 2>/dev/null";

char*dlg  =  "$(zenity --question --width=300 --text='Admin nick was used, Do you want overwrite?' 2>/dev/null); echo $? ";

char*zen_end = "zenity --info --width=300 --text 'Registration-key has been saved'  2>/dev/null";


	struct stat sb;

	int i;
	char str[256] = "null";
	char st[256];
	char pad[4096];
	char name[80];
	char passwd[80];
	char rpasswd[80];
	char pesel[15] = "null";
	char*p;
	char*e;
	char*s; 

	srand((unsigned int)time(NULL)+5);

	for(i=0; i<4096; i++) {
		*(pad+i) = rand()/255;
	}

	//pyta o pesel admina
	FILE*fp = popen(psl, "r");
	if(fp == NULL)  exit(0);
	fgets(pesel, 15, fp);
	pclose(fp);
	p = strchr(pesel, '\n');
	if(p != NULL) *p = '\0';
 	if(strcmp(pesel, "null") == 0) exit(0); //klawisz CANCEL

	//sprawdza formule pesel
	if(!check_form_pesel(pesel)) {
		fp = popen(psl_err, "r");
		if(fp != NULL)  pclose(fp);
		exit(0);
	}

	//pobiera dane z zenity
	fp = popen(zen, "r");
	if(fp == NULL)  exit(0);
	fgets(str, 80, fp);
	pclose(fp);


	if(strcmp(str, "null") == 0) exit(0); //klawisz CANCEL

	p = strchr(str, '|');
	e = strrchr(str, '|');
	s = strchr(str, '\0');
	if(p == NULL) exit(0); 
	if(e == NULL) exit(0);
	if(s == NULL) exit(0);

	memcpy(name, &str[0], p-&str[0]);
	i = p-&str[0];
	*(name+i) = '\0';

	memcpy(passwd, p+1, e-(p+1));
	i = (int)(e-(p+1));
	*(passwd+i) = '\0';

	memcpy(rpasswd, e+1, s - (e+1));
	i = s-1 - (e+1);
	*(rpasswd+i) = '\0';

	//sparwdza czy rpasswd jest taki jak passwd
	if(strcmp(passwd, rpasswd) != 0) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}

	if(strlen(passwd)<4) {
		fp = popen(err1, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}

	//dlugosc pawword nie powinna byc wieksza niz 20 znakow
	//obcina do 20 chars.
	if(strlen(passwd)>20) *(passwd+20) = '\0';

	strcpy(str, "NAME=");
	strcat(str, name);
	strcat(str, "&PESEL=");
	strcat(str, pesel);
	strcat(str, "&PASSWD=");
	strcat(str, passwd);
	strcat(str, "&");

	memcpy(pad, &str[0], strlen(str)+1);

	strcpy(str, "USERS-KEYS");
	mkdir(str, 0777);
	strcat(str, "/");
	strcat(str, name);
	mkdir(str, 0777);

	//dodaje nazwe pliku
	strcat(str, "/");
	strcat(str, FILE_KEY_NAME);

	//sprawdza czy dokonac overwrite admin
	strcpy(st, str);
	strcat(st,".archi");
	if(stat(st, &sb) == 0) {
		//0 - YES, 1 -NO
		fp = popen(dlg, "r");
		if(fp == NULL) exit(0);
		fgets(st, 20, fp);
		fclose(fp);
		p = strchr(st, '1'); //NO
		if(p != NULL) exit(0);
	}

	//zapis do pliku
	fp = fopen(str, "w");
	if(fp == NULL) exit(0);
	fwrite(pad, 4096, 1, fp);
	fclose(fp);
	
	//szyfrowanie pliku
	if(leszif3code(str, passwd, 1) < 0) {
		remove(str);
		fp = popen(err2, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}
		
	remove(str);

	fp = popen(zen_end, "r");
	if(fp != NULL) pclose(fp);
}




int main() {

	printf("\n --- START REGISTER ADMIN UIDC ---\n\n");

	make_registertation_key();

	printf("\n --- END REGISTER ADMIN UIDC ---\n\n");


return 0;
}


