///////////////////////////////////////////////////////////////////////////////
//
//
//	            	Administrator UIDC
//	            	    (JPW-2019)
//	            	     ver 0.1
//
//
//	Uwagi.
//	1. wprowadzenie daty dziennej lub przeszlej powoduje ustalenie
//	   waznosic START-CODE bez ograniczenia w czasie
//	2. Wprowadzenie daty przyszlej (nawet o jeden dzien) powoduje
//	   limit czasu waznosci START-CODE.
//
///////////////////////////////////////////////////////////////////////////////

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dirent.h> 
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#ifndef SELECT 
#define SELECT
#include "SRC/select_value.c" 
#endif
#include "UID_CLIENT/clientUID.h"


#define STRING_READ_SIZE 512 //odczytywany string z pliku UIDBase, max = 2048
#define PATH_SIZE 512 //dlugosc stringu path+filename .../UIDBase
#define CONFIG_FILENAME "uidc.config"


//nazawy plikow
char path_CSV[PATH_SIZE] = "TMP";
char ipaddress[20] = "127.0.0.1"; //adress serwera
int port = 8809;  






///////////////////////////////////////////////////////////////////////////////
//----------------------- SPRAWDZANIE FORMUL PESEL ----------------------------
///////////////////////////////////////////////////////////////////////////////
//sprawdza formule pesel/nip/regon
int check_form_pesel(const char*pesel) {

	int sum;
	int i;

//printf("NIP: %s\n", pesel);

	if(strlen(pesel) != 11) return 0; //za krotki lub za dlugi PESEL
	if(strcmp(pesel, "N0000000000") == 0) return 0; //odrzucony NIP

	//selekcja pesel, nip, regon, konto specjalne
	if(pesel[0] == 'N') goto label_nip;
	if(pesel[0] == 'R' && pesel[1] == 'N') goto label_regon;
	if(pesel[0] == 'R' && pesel[1] == 'S') goto label_specjal;

	//sprawdza wytepowanie cyfr w stringu pesel
	for(i=0; i<11; i++) {
	   if( *(pesel+i)<'0' && *(pesel+i)>'9') return 0;
	}
	
	//sprawdza formule pesel
	//9×a + 7×b + 3×c + 1×d + 9×e + 7×f + 3×g + 1×h + 9×i + 7×j
	sum = 	9*(pesel[0] - 48) +
		7*(pesel[1] - 48) +
		3*(pesel[2] - 48) +
		1*(pesel[3] - 48) +
		9*(pesel[4] - 48) +
		7*(pesel[5] - 48) +
		3*(pesel[6] - 48) +
		1*(pesel[7] - 48) +
		9*(pesel[8] - 48) +
		7*(pesel[9] - 48);
	//oblicza reszte
	sum %= 10;

	//sprawdza reszte z ostania cyfra
	if(sum == pesel[10]-48) return 1;
	else return 0;

label_nip:
//puts("---nip");
	//sprawdza cyfry w stringu pesel
	for(i=1; i<11; i++) {
	   if( *(pesel+i)<'0' && *(pesel+i)>'9') return 0;
	}

	//sprawdza formule nip
	//wagi 6, 5, 7, 2, 3, 4, 5, 6, 7
	sum =	6*(pesel[1] - 48) +
		5*(pesel[2] - 48) +
		7*(pesel[3] - 48) +
		2*(pesel[4] - 48) +
		3*(pesel[5] - 48) +
		4*(pesel[6] - 48) +
		5*(pesel[7] - 48) +
		6*(pesel[8] - 48) +
		7*(pesel[9] - 48);
	//oblicza reszte
	sum %= 11;
//printf("SUM: %d\n", sum);
	if(sum == pesel[10]-48) return 1;
	else return 0;
	

label_regon:

	//sprawdza cyfry w stringu pesel
	for(i=2; i<11; i++) {
	   if( *(pesel+i)<'0' && *(pesel+i)>'9') return 0;
	}

	//sprawdza formule regon
	//wagi: 8, 9, 2, 3, 4, 5, 6, 7
	sum = 	8*(pesel[2] - 48) +
		9*(pesel[3] - 48) +
		2*(pesel[4] - 48) +
		3*(pesel[5] - 48) +
		4*(pesel[6] - 48) +
		5*(pesel[7] - 48) +
		6*(pesel[8] - 48) +
		7*(pesel[9] - 48);
	//oblicza reszte
	sum %= 11;
	if(sum == 10) sum = 0;
	if(sum == pesel[10]-48) return 1;
	else return 0;


label_specjal:

	//sprawdza cyfry w stringu specjalnym
	sum = 1;
	for(i=2; i<11; i++) {
	   if( *(pesel+i)<'0' && *(pesel+i)>'9') sum = 0;
	}
	if(sum) return 1;

	return 0;
}
///////////////////////////////////////////////////////////////////////////////
//--------------------- END SPRAWDZANIE FORMUL PESEL --------------------------
///////////////////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////////////////
//                             ADD TO A FILE
///////////////////////////////////////////////////////////////////////////////

int add_to_file(const char*path, const char*str) {

	FILE*fd = fopen(path, "a");
	if(fd == NULL) return -1;
	fprintf(fd, "%s\n", str);
	fflush(fd);
	fclose(fd);
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//                             ADD TO A FILE
///////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////
//                             CURRENT DATE
///////////////////////////////////////////////////////////////////////////////
//DATE=20170130-h:m:s&
int get_time(char*data) {
	char st[10];
	struct tm *ts;
	time_t tt;
	if(time(&tt)==-1) {strcpy(data,"NULL"); return -1;}
	//year
	ts=localtime(&tt);
	int x=1900+ts->tm_year;
	sprintf(st,"%d",x);
	strcpy(data,"DATE=");
	strcat(data,st);
	//month
	x=ts->tm_mon;x++; //poniwaz miesac liczny jest od 0..
	sprintf(st,"%d",x);
	if(strlen(st)==1) strcat(data,"0");
	strcat(data,st);
	//day
	x=ts->tm_mday;
	sprintf(st,"%d",x);
	if(strlen(st)==1) strcat(data,"0");
	strcat(data,st);
	strcat(data,"-");
	//hour
	x=ts->tm_hour;
	sprintf(st,"%d",x);
	if(strlen(st)==1) strcat(data,"0");
	strcat(data,st);
	strcat(data,":");
	//minuta
	x=ts->tm_min;
	sprintf(st,"%d",x);
	if(strlen(st)==1) strcat(data,"0");
	strcat(data,st);
	strcat(data,":");
	//sec
	x=ts->tm_sec;
	sprintf(st,"%d",x);
	if(strlen(st)==1) strcat(data,"0");
	strcat(data,st);
	strcat(data,"&");
	return 0;
}
///////////////////////////////////////////////////////////////////////////////
//                           END CURRENT DATE
///////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////
//--------------------------- PATH+nazwa bazy UIDBase -------------------------
///////////////////////////////////////////////////////////////////////////////
//Odczyt pliku konfiguracyjnego
int read_config(void) {
	char st[PATH_SIZE];
	char out[PATH_SIZE];
	FILE*fd = fopen(CONFIG_FILENAME,"r");
	if(fd==NULL) return -1;
	while(fgets(st,PATH_SIZE,fd)!=NULL) {
	if(st[0]!='#') {
	   select_value(st,"PATH",out);
	   if(strcmp(out,"NULL")!=0) strcpy(path_CSV,out);
	   select_value(st,"IPSERV",out);
	   if(strcmp(out,"NULL")!=0) strcpy(ipaddress,out);
	   select_value(st,"PORT",out);
	   if(strcmp(out,"NULL")!=0) port = atoi(out);
	   }
	}
	fclose(fd);
	return 0;
}
///////////////////////////////////////////////////////////////////////////////
//-------------------------- END CONFIG UIDBase -------------------------------
///////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////
//--------------------- TESTOWANIE OBECNOSCI SERVERA --------------------------
///////////////////////////////////////////////////////////////////////////////
//testuje obenosc serwera
int test_server(void) {
	char reply[256];
	char *p;
	char *st = "TEST=H00&";

	client_U(ipaddress, port, st, reply);
	p = strstr(reply, "REPLY=mserverUID_CENTRAL&");
	if( p != NULL ) return 1;
	return 0;
}
///////////////////////////////////////////////////////////////////////////////
//----------------- END TESTOWANIE OBECNOSCI SERVERA --------------------------
/////////////////////////////////////////////////////////////////////////////// 



///////////////////////////////////////////////////////////////////////////////
//			   INPUT DATA FROM ZENITY
///////////////////////////////////////////////////////////////////////////////

//--- wybor zadania ---
int zenity_selection_task(void) {
char*zen = "zenity  --list --width=300 --height=220 --text 'Central Admin' --radiolist  --column 'Select' --column 'Function' TRUE 'Registration Code' FALSE 'Block User' FALSE 'Block Node' FALSE 'Last Log' 2>/dev/null"; 

	char st[80];
	char*p;

	strcpy(st, "null");

	FILE*fp = popen( zen, "r");
	if(fp == NULL) exit(0);
	fgets(st, 80, fp);
	pclose(fp);

	
	p = strstr(st, "null");
	if(p != NULL) exit(0); 	//klawisz CANCEL
	p = strstr(st, "User");
	if(p != NULL) return 2;	//blokowanie uzytkownika
	p = strstr(st, "Node");
	if(p != NULL) return 3;	//blokowanie Node
	p = strstr(st, "Log");
	if(p != NULL) return 4;

	return 1;					//Rejestracja nowego NODE
}



//--- rejestracja nowego node ---
int zenity_input_registration(char *str, int lenstr) {
char* zen =  "zenity --forms --title='START-CODE' --text='Enter node name and expiration date.' --separator='|' --add-entry='Name Node/Info' --add-calendar='Expiration date' --forms-date-format='%Y%m%d' 2>/dev/null";

	strcpy(str, "null");

	char date[40];
	char vdate[40];
	char *p;
	char *e;

	FILE*fp = popen( zen, "r");
	if(fp == NULL) return -1;
	fgets(str, lenstr, fp);
	pclose(fp);

	//nacisniety klawisz CANCEL
	p = strstr(str, "null");
	if(p != NULL) {strcpy(str, "null"); return -1;} 

	p = strchr(str, '|');
	if( p == NULL) {strcpy(str, "null"); return -1;} //nieprawidlowy format

	if(p-&str[0] < 2)  {strcpy(str, "null"); return -1;} //brak nazwy

	e = strchr(str, '\0');
        memcpy(vdate, p+1, e+1-p); 
	*(vdate+8) = '\0';

	//zle dziala zegarek w komputerze admina
	if(get_time(date) < 0) {strcpy(str, "error-system"); return -1;} 
	select_value(date, "DATE", date);

	//blad select_value
	if(strcmp(date, "NULL") == 0) {strcat(str,"error-system"); return -1;} 
	p = strchr(date, '-');
	if(p != NULL) *p = '\0';

	//sprawdza czy wprowadzona data nie jest stara
	if(atoi(vdate) <= atoi(date)) {
		p = strchr(str, '|');
		*(p+1) = '\0';
		strcat(str, "null");  
	}

	//printf("ZEN: %s\n", str);
	
	return 0;
}


//--- wprowadzenie danych do zablokowania uzytkownika ---
void zenity_block_user(char*pesel) {
char* zen  =  "zenity --entry --title='Block User' --text 'Enter PESEL' 2>/dev/null";
char* err  = "zenity --error --width=200 --text 'Incorrect PESEL length!' 2>/dev/null";
char* err1 = "zenity --error --width=200 --text 'Incorrect PESEL form!' 2>/dev/null";

	char st[15];
	char*p;

	strcpy(st, "null");

	FILE*fp = popen( zen, "r");
	if(fp == NULL) exit(0);
	fgets(st, 15, fp);
	pclose(fp);

	p = strstr(st, "null");
	if(p != NULL) exit(0); 	//klawisz CANCEL

	p = strchr(st, '\n');
	if(p != NULL) *p = '\0';

	if(strlen(st) != 11) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}

	strcpy(pesel, st); 
	if(strcmp(pesel, "null") != 0) {
		if(!check_form_pesel(pesel)) {
			fp = popen(err1, "r");
			if(fp != NULL) pclose(fp);
			exit(0);
		}
	}
}


//blokowanie departamentu lub wszystkich departamentow w wezle
void zenity_block_dept(char*dep, char*nip, char*regon) {
	char* zen =  "zenity --forms --title='Block Department' --text='Enter data' --separator='|' --add-entry='Department' --add-entry='NIP' --add-entry='REGON' 2>/dev/null";
	char* err  = "zenity --error --width=200 --text 'Incorect Form!' 2>/dev/null";
	char* err1  = "zenity --error --width=200 --text '[1] Incorrect Form!' 2>/dev/null";
	char* err2  = "zenity --error --width=200 --text '[2] Incorrect Form!' 2>/dev/null";
	char* err3  = "zenity --error --width=200 --text '[3] Incorrect Form!' 2>/dev/null";
	char* err4  = "zenity --error --width=200 --text '[4] Incorrect Form!' 2>/dev/null";
	char* err20 = "zenity --error --width=200 --text 'Dep too long (max. 12 chars)!' 2>/dev/null";
	char* err21 = "zenity --error --width=200 --text 'NIP null or 11 chars!' 2>/dev/null";
	char* err22 = "zenity --error --width=200 --text 'REGON null or 11 chars!' 2>/dev/null";
	char* err23 = "zenity --error --width=200 --text 'Incorrect NIP form!' 2>/dev/null";
	char* err24 = "zenity --error --width=200 --text 'Incorrect REGON form!' 2>/dev/null";

 	int i,k;
	char st[80];
	char*p;
	char*q;
	char*e;

	strcpy(st, "null");

	FILE*fp = popen( zen, "r");
	if(fp == NULL) exit(0);
	fgets(st, 80, fp);
	pclose(fp);

	//sprawdza sumarcyzna dlugosc wpisow
	if(strlen(st)>12+12+12) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}

	p = strstr(st, "null");
	if(p != NULL) exit(0); 	//klawisz CANCEL

	k = 0;
	for(i=0; i<(int)strlen(st); i++) {
		if(*(st+i) == '|') k++;
	}
	if(k != 2) {
		fp = popen(err1, "r"); 
		if(fp != NULL) pclose(fp);
		exit(0);
	} //nieprawidlowy format

	p = strchr(st, '|');
	if( p == NULL)  {
		fp = popen(err2, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	} //nieprawidlowy format

	i = (int)(p-&st[0]);
	if(i>12) {
		fp = popen(err20, "r"); //max 12 chars w nazwie departamentu
		if(fp != NULL) pclose(fp);
		exit(0);
	}
	if(p-&st[0] < 2)  strcpy(dep, "null"); //wszystkie departamenty
	else {
		memcpy(dep, &st[0], p-&st[0]);
		*(dep + i+1) = '\0'; 
	}
	
	// --- nip, regon ---
	q = strrchr(st, '|');
	if(q == NULL) {
		fp = popen(err3, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	} //nieprawidlowy format

	e = strchr(st, '\0');
	if(e == NULL) {
		fp = popen(err4, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	} //nieprawidlowy format

	i = (int) (q-p-1);
	k = (int)(e-q-2);

	if(i>11) {
		fp = popen(err21, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}

	if(k>11) {
		fp = popen(err22, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}

	if(i != 11) strcpy(nip, "null");
	else {
		memcpy(nip, p+1, q-(p+1));
		*(nip+i) ='\0';
	}

	if(k != 11) strcpy(regon, "null");
	else {
		memcpy(regon, q+1, e-(q+1));
		*(regon+k) = '\0';
	}

	//sprawdznie popraneosci fomuly NIP
	if(strcmp(nip, "null") != 0) {
		if(!check_form_pesel(nip)) {
			fp = popen(err23, "r");
			if(fp != NULL) pclose(fp);
			exit(0);
		}
	}

	//sprawdzanie fomuly REGON
	if(strcmp(regon, "null") != 0) {
		if(!check_form_pesel(regon)) {
			fp = popen(err24, "r");
			if(fp != NULL) pclose(fp);
			exit(0);
		}
	}

}
///////////////////////////////////////////////////////////////////////////////
//			   INPUT FROM ZENITY
///////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////
//                             GET START-CODE
///////////////////////////////////////////////////////////////////////////////

void format_reply(char*str) {

	char st[512];
	char dt[15];
	char dat[10];
	char cod[80];
	char *p;
	char *e;
	char *s;

	p = strchr(str, '|');
	if(p == NULL) return;

	e = strchr(str, '\0');
	if(e == NULL) return;

	memcpy(st, p+1, e-(p+1));
	p = strchr(st, '|');
	if(p == NULL) return;

	e = strchr(st, '\0');
	if(e == NULL) return;
	
	memcpy(dat, &st[0], p+1 - &st[0]);

	s = strchr(dat, '|');
	if(s == NULL) return;
	else *s = '\0';

	dt[0]  = dat[0];
	dt[1]  = dat[1];
	dt[2]  = dat[2];
	dt[3]  = dat[3];
	dt[4]  = '-';
	dt[5]  = dat[4];
	dt[6]  = dat[5];
	dt[7]  = '-';
	dt[8]  = dat[6];
	dt[9]  = dat[7];
	dt[10] = '\0';

	memcpy(cod, p+1, (e+1)-(p+1));

	strcpy(str, cod);
	strcat(str, ",  valid until: ");
	strcat(str, dt);
} 


//pobiera z sewera kod rejestracyjny i laczy z danymi wprowadzonymi przez
//administratora.                           
int get_start_code(char * str_code, int show) {

	char zen[256];
	FILE*fp;
	char name[80];
	char vdate[20];
	char qstr[128];


	//pobiera dane z pliku konfiguracyjnego
	if(read_config() < 0) {
	    fp = popen("zenity --error --width=200 --text 'Error: missing config file!' 2>/dev/null", "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);
	}

	//sprawdza obecnosc polaczenia z serwerem
	if(!test_server()) {
	    fp = popen("zenity --error --width=200 --text 'No connection with server!' 2>/dev/null", "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);
	}

	//admin wprowadza dane z okienka
	if(zenity_input_registration(zen, 100) < 0) {
	    fp = popen("zenity --error --width=200 --text 'Incorret entry!' 2>/dev/null", "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);
	}

	//jesli nazwa jest za dluga
	if(strlen(zen)>90) {
	    fp = popen("zenity --error --width=200 --text 'too long name in the field (max.80 chars)!' 2>/dev/null", "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);
	}

	if(strcmp(zen, "null") == 0) return -1; //jesli nie bylo danych lub byl CANCEL

	//jesli wystapi blad select_value lub zegarka systemowego
	if(strcmp(zen, "error-system") == 0) {
	    fp = popen("zenity --error --width=200 --text 'System error!' 2>/dev/null", "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);	
	} 

		
	//przygotowanie q-vectora
	int i = 0;
	while(i<80 && *(zen+i) !='|') {
		*(name+i) = *(zen+i);
		i++;
	} 
	*(name+i) = '\0';
	
	//separacja daty 
	char *p = strchr(zen, '|');
	char *e = strchr(zen, '\0');
	memcpy(vdate, p+1, e+1-p); 
	*(vdate+8) = '\0';

	//FORMAT QSTR: OP=get_start_code&VDATE=201910823& 
	strcpy(qstr, "OP=get_start_code&VDATE=");
	strcat(qstr, vdate);
	strcat(qstr, "&");

	//printf(" Name: %s\n", name);
	//printf("Vdata: %s\n", vdate);
	//printf("QSTR:  %s\n", qstr);

	//pobieranie start-code (rejestracji node) z servera UIDC
	char reply[256];
	client_U(ipaddress, port, qstr, reply);

	select_value(reply, "CODE", name);
	if(strcmp(name, "NULL") == 0) {
	    fp = popen("zenity --error --width=200 --text 'No code from server[1]!' 2>/dev/null", "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);
	}

	if(strcmp(name, "null") == 0) {
	    strcpy(str_code, "null");
	    fp = popen("zenity --error --width=200 --text 'No code from server[2]!' 2>/dev/null", "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);
	}

	//dodaje pobrany kod do rejestracji node
	p = strchr(zen, '\n');
	if(p != NULL) *p = '\0';
	strcat(str_code, zen);
        strcat(str_code, "|");
	strcat(str_code, name);

	//zapisuje do pliku csv
	umask(0);
	mkdir(path_CSV, 0777);
	strcat(path_CSV, "/");
	strcat(path_CSV, "list_start_codes.csv");
	add_to_file(path_CSV, str_code); 

	strcpy(zen, "zenity --info --width=600 --text '");
	format_reply(str_code);
	strcat(zen, str_code);
	strcat(zen, "' 2>/dev/null");

	//wyswietla code-string
	if(show ==1 ) {
		fp = popen(zen, "r");
		if(fp != NULL) pclose(fp);
	}
	
	return 0;
}
///////////////////////////////////////////////////////////////////////////////
//                             GET START-CODE
///////////////////////////////////////////////////////////////////////////////  




///////////////////////////////////////////////////////////////////////////////
//                                Block Node
///////////////////////////////////////////////////////////////////////////////
void admin_block_node(void) {

	char*err = "zenity --error --width=200 --text 'No connection with UIDC!' 2>/dev/null";
	char*er1 = "zenity --error --width=200 --text 'Reply NULL (error of UIDC)!' 2>/dev/null";
	char*er2 = "zenity --error --width=200 --text 'Internal error of UIDC!' 2>/dev/null";
	char*rep = "zenity --info --width=200 --text 'Node has been blocked!' 2>/dev/null";

	char*cfg = "zenity --error --width=200 --text 'Error: missing config file!' 2>/dev/null";
	char*tst = "zenity --error --width=200 --text 'No connection with server!' 2>/dev/null";

	int ret;
	char dep[15], nip[15], regon[15];
	char qstr[512];
	char reply[256];
	FILE*fp;

	//pobiera dane z pliku konfiguracyjnego
	if(read_config() < 0) {
	    fp = popen(cfg, "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);
	}

	//sprawdza obecnosc polaczenia z serwerem
	if(!test_server()) {
	    fp = popen(tst, "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);
	}


	zenity_block_dept(dep, nip, regon);
	if(strcmp(nip, "null") == 0) {
		if(strcmp(regon, "null") == 0) exit(0);
	}

	//tworzenie qstr - polecenie dla UIDC
	strcpy(qstr, "OP=block_department&DEP=");
	strcat(qstr, dep);
	strcat(qstr, "&NIP=");
	strcat(qstr, nip);
	strcat(qstr, "&REGON=");
	strcat(qstr, regon);
	strcat(qstr, "&");

	//wysyla qstr do UIDC
	ret = client_U(ipaddress, port, qstr, reply);
	if(ret < 0) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}
	
	// --- analiza odpowiedzi ---
	select_value(reply, "STATUS", qstr);
	if(strcmp(qstr, "NULL") == 0) {
		fp = popen(er1, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}	

	// EUID zostal zmieniony w systemie (NODE/DEP zablokowane poprawnie)
	if(strcmp(qstr, "done") == 0) {
		fp = popen(rep, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	} 
	
	// jesli byly bldey serwera UIDC
	fp = popen(er2, "r");
	if(fp != NULL) pclose(fp);
	exit(0);
}
///////////////////////////////////////////////////////////////////////////////
//                               END Block Node
///////////////////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////////////////
//                                 Block User
///////////////////////////////////////////////////////////////////////////////
void admin_block_user(void) {

	int ret; 
	char*err = "zenity --error --width=200 --text 'No connection with UIDC!' 2>/dev/null";
	char*er1 = "zenity --error --width=200 --text 'Reply NULL (error of UIDC)!' 2>/dev/null";
	char*er2 = "zenity --error --width=200 --text 'Internal error of UIDC!' 2>/dev/null";
	char*rep = "zenity --info --width=200 --text 'User has been blocked!' 2>/dev/null";
	char*tst = "zenity --error --width=200 --text 'No connection with server!' 2>/dev/null";


	FILE*fp;

	char pesel[15];
	char qstr[512];
	char reply[256];


	//sprawdza obecnosc polaczenia z serwerem
	if(!test_server()) {
	    fp = popen(tst, "r");
	    if(fp != NULL) pclose(fp);
	    exit(0);
	}


	zenity_block_user(pesel);

	strcpy(qstr, "OP=block_user_by_central_admin&PESEL=");
	strcat(qstr, pesel);
	strcat(qstr, "&");

	//wysyla qstr do UIDC
	ret = client_U(ipaddress, port, qstr, reply);
	if(ret < 0) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}

	select_value(reply, "STATUS", qstr);
	if(strcmp(qstr, "NULL") == 0) {
		fp = popen(er1, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}		

	if(strcmp(qstr, "done") == 0) {
		fp = popen(rep, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	} 
	
	fp = popen(er2, "r");
	if(fp != NULL) pclose(fp);
	exit(0);
}
///////////////////////////////////////////////////////////////////////////////
//                               END Block User
///////////////////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////////////////
//                              Last login admin
///////////////////////////////////////////////////////////////////////////////

//20190901-22:16:13 -> 2019-09-01, 22:16:13
void format_date(char*dat) {

   char dt[21]; 

	dt[0]  = dat[0];
	dt[1]  = dat[1];
	dt[2]  = dat[2];
	dt[3]  = dat[3];
	dt[4]  = '-';
	dt[5]  = dat[4];
	dt[6]  = dat[5];
	dt[7]  = '-';
	dt[8]  = dat[6];
	dt[9]  = dat[7];
	dt[10] = ',';
	dt[11] = ' ';
	dt[12] = dat[9];
	dt[13] = dat[10];
	dt[14] = dat[11];
	dt[15] = dat[12];
	dt[16] = dat[13];
	dt[17] = dat[14];
	dt[18] = dat[15];
	dt[19] = dat[16];
	dt[20] ='\0';

	strcpy(dat, dt);
}


//ppobiera inforamcje o ostatnim logowaniu admina 
void last_login(void) {

char* zen =  "zenity --forms --width=200 --title='Last Admin Login' --text='Enter PESEL or NICK' --separator='|' --add-entry='NICK' --add-entry='PESEL' 2>/dev/null";
char*err = "zenity --error --width=200 --text 'Incorrect entry data!' 2>/dev/null";
char*err1 = "zenity --error --width=200 --text 'No connection with UIDC!' 2>/dev/null";

char*info1 = "zenity --info --width=200 --text 'Admin was never loged!' 2>/dev/null";


	int ret;
	char str[256];
	char nick[80];
	char pesel[80];
	char status[20];
	char date[30];
	char reply[256];
	char*p;
	char*e;
	char*s;
	FILE*fp;

	strcpy(str, "null");
	fp = popen(zen, "r");
	if(fp == NULL) exit(0);
	fgets(str, 256, fp);
	pclose(fp);
	if(strcmp(str, "null") == 0) exit(0);
   p = strchr(str, '\n');
	if(p != NULL) *p = '\0';

	p = strchr(str, '|');
	if(p == NULL) exit(0);

	e = strchr(str, '\0');
	if(e == NULL) exit(0);

	memcpy(nick, &str[0], p+1-&str[0]);
	s = strchr(nick, '|');
	if(s != NULL) *s = '\0';
	
	if(strlen(nick) == 0) strcpy(nick, "null");

	memcpy(pesel, p+1, (e+1)-p);

	if(strlen(pesel) != 11) strcpy(pesel, "null");


	if(strcmp(pesel, "null") == 0 && strcmp(nick, "null") == 0) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}
	if(strcmp(nick, "null") != 0) strcpy(pesel, "null");
	
	strcpy(str, "OP=get_last_log&PESEL=");
	strcat(str, pesel);
	strcat(str, "&NICK=");
	strcat(str, nick);
	strcat(str, "&");

	ret = client_U(ipaddress, port, str, reply);
	if(ret < 0) {
		fp = popen(err1, "r");
		if(fp != NULL) pclose(fp);
		exit(0);
	}

//printf("REP[1]: %s\n", reply);

	select_value(reply, "STATUS", status);

	if(strcmp(status, "done") == 0) {
	
		select_value(reply, "NICK", nick);
		if(strcmp(nick, "NULL") == 0) strcpy(nick, "null");
		select_value(reply, "DATE", date);
		if(strcmp(date, "NULL") == 0) strcpy(date, "null"); 

		if(strcmp(date, "null") == 0) {
			fp = popen(info1, "r");
			if(fp != NULL) pclose(fp);
			exit(0);
		}
		else {
			strcpy(str, "zenity --info --width=200 --text 'Date last login: ");
			format_date(date);
			strcat(str, date);
			strcat(str, "' 2>/dev/null");
 			fp = popen(str, "r");
			if(fp != NULL) pclose(fp);
			exit(0);			
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
//                              END Last login admin
///////////////////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////////////////
//                            INIT WINDOW
///////////////////////////////////////////////////////////////////////////////

int init_windows(void) {
char* zen  =  "zenity --entry --width=200 --title='ADMIN UIDC' --text 'Enter Name/Nick' 2>/dev/null";
char*err = "zenity --error --width=200 --text 'No connection with UIDC!' 2>/dev/null";

	int ret;
	char name[80];
	char pesel[80];
	char str[256] = "./check_admin CH201908DD30 ";
	char reply[256];

	strcpy(name, "null");
	FILE*fp = popen(zen, "r");
	if(fp == NULL) return -1;
	fgets(name, 20, fp);
	pclose(fp);

	if(strcmp(name, "null") == 0) return -1; // klawisz CANCEL

	char*p = strchr(name, '\n');
	if(p != NULL) *p = '\0';

	//check admin UIDC
	strcat(str, name);

	system(str);

	fp = fopen("tmp.q", "r");
	if(fp == NULL) return -1;
	fgets(str, 256, fp);
	fclose(fp);
	remove("tmp.q");

	select_value(str, "PESEL", pesel);
	if(strcmp(pesel, "NULL") == 0) strcpy(pesel, "null");

	//sparawdza obecnoć serwera
	if(!test_server()) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		return -1;
	}

	//wysyla dane logowania do UIDC
	//	OP=log_adm&PESEL=...&NICK=..&
	strcpy(str, "OP=log_adm&PESEL=");
	strcat(str, pesel);
	strcat(str, "&NICK=");
	strcat(str, name);
	strcat(str, "&");
	ret = client_U(ipaddress, port, str, reply);
	if(ret < 0) {
		fp = popen(err, "r");
		if(fp != NULL) pclose(fp);
		return -1;
	}
//printf("REP: %s\n", reply);
	select_value(reply, "STATUS", str);
//printf("STR: %s\n", str);
	if(strcmp(str, "NULL") == 0) return -1;
	if(strcmp(str, "refused") == 0) return -1;

	return 0;
}
///////////////////////////////////////////////////////////////////////////////
//                            INIT WINDOW
///////////////////////////////////////////////////////////////////////////////





int main() {

char*cfg = "zenity --error --width=200 --text 'Error: missing config file!' 2>/dev/null";
char*err = "zenity --error --width=200 --text 'Cannot login!' 2>/dev/null";


	char str[256];
	int ret; 
	FILE*fp;
	


	//pobiera dane z pliku konfiguracyjnego
	if(read_config() < 0) {
	    fp = popen(cfg, "r");
	    if(fp != NULL) pclose(fp);
	    return 0;
	}

	//sprrawdza admina
 	ret = init_windows();
	if(ret < 0) {
		 fp = popen(err, "r");
	    if(fp != NULL) pclose(fp);
		return 0;
	}
	
	


	// 1 - nowy dep/node
	// 2 - blokowanie User (zmiana EUIDP)
	// 3 - blokowanie Node (zmiana EUID)
	// 4 - ostatnie logowanie dowolnego admina
	ret = zenity_selection_task();

  

	//tworzenie start-code dla nowego NODE
	if(ret == 1) {
 		ret = get_start_code(str, 1);
 		if (ret  == 0) {
			printf("\n  New start-code to registration node:\n"); 
 			printf("  %s\n\n", str);
  		}
	return 0;
	}

	//blokowanie USER
	if(ret == 2) {
		admin_block_user();
		return 0;
	}

	//blokowanie NODE
	if(ret == 3) {
 		admin_block_node();
		return 0;
	}

	//last login
	if(ret == 4) {
		last_login();
	}
 
	return 0;
}
