/******************************************************************************
 *
 *	                                  ARCHI
 *	                              executorUIDC
 *	                                ver 0.2
 *	                       (lib. for mserverUIDC)
 *                              (JPW - 2019)
 *
 *
 ******************************************************************************
 */



#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifndef SELECT 
#define SELECT
#include "SRC/select_value.c" 
#endif



#ifndef CLIENTUID
#define CLIENTUID
//#include "SRC/code_pass.c" //coder/decoder
#include "SRC/clientUID_exec_func.c" //coder/decoder
#endif



#include "exec_functions_UIDC.c"



#define TEST_H00 "REPLY=mserverUID_CENTRAL&" //<-- id serwera 





//---------------------------------- ANALIZATOR ------------------------------- 

int analizator(const char*in, char*out, const char*ip_client) {

	char value[80];
        char test_h00[80];


	//--- test obecnosci serwera ---
	//query: TEST=H00&; 
	//reply: "REPLY=mserverUID_CENTRAL001&"
	select_value(in,"TEST",test_h00);
	if(strcmp(test_h00,"H00")==0) {
		strcpy(out,TEST_H00); 
		return 1;
	}


	select_value(in,"OP",value);

	
 	// --- Obsluga Kodu rejestracyjnego ---

	// ---generowanie START_CODE dla rejestracji nowego UIDL ---
	//(kod rejstracyjny pobiera admin UIDC)
	//OP=get_start_code&VDATE=201910823& 
	////VDATE data wanosci kodu rejestracyjnego
	//jesli VDATE=null& lub brak VDATE w qstr to nie bedzie badany 
	//okres waznosci startowego kodu
	//RE=get_start_code&CODE=...& //lub ...CODE=null& 
	//Kod rejestracyjny znajduje sie w pliku START/A/B/C/SCODE
	if(strcmp(value, "get_start_code") == 0) {
	return start_code(in, out, ip_client);
	}

	// --- sprawdzanie codu stratowego dla rejestracji node ---
	//(kod rejestracyjny sprawdza admin UIDL, kod otrzymuje np. via sms))
	//OP=chk_scode&CODE=...& //code przeslny przy rejestracji
	//RE=chk_scode&STAT=done& // jesli brak zgodnosci CODE=null&
	if(strcmp(value, "chk_scode") == 0) {
	return chk_start_code(in, out);
	}
	// --- Koniec obslugi Kodu rejestracyjnego ---




	// --- Generowanie UID32&EUID oraz UIDP&EUIDP ---
	
	// UID tzn. UID32=..&EUID=...&
	if(strcmp(value,"get_UID64")==0) {
	return get_UID64(out);
	}


	// --- tworzenie konta specjalnego "RS"---
	
	//tworzy konto specjalne RS, ktore jest rejestrowane w UIDC
	//podobnie jak konta numerczyne PESEL N, RN
	//OP=get_special_pesel&
	//Zwraca: 
	//   RE=get_special_pesel&STATUS=done&PESEL=RS000000103&
	//   lub w przypadku bledu
	//   RE=get_special_pesel&STATUS=refused&CP=<powod bledu>&
	if(strcmp(value,"get_special_pesel")==0) {
	return get_special_pesel(in, out);
	}


	// --- departament ---
	
	// rejestracja departamentu (nowego NODE)
	//OP=add_department&UID32=null&EUID=null&NAME=..&DEP=...
	//   &NIP=..&REGON=...&LIP=...&PUID=...&PORTP=..&PORTQ=...&NODES=...&
	//Zwraca:
	//
	//RE=add_department&STATUS=done&UID32=..&EUID=..&
	//lub
	//RE=add_department&STATUS=refused&
	if(strcmp(value, "add_department")==0) {
	return add_department(in, out);
	}


	//blokowanie departamentu (z poziomu UIDC, obsluga przez admina)
	//(tylko dla admina)
	//OP=block_department&DEP=..&NIP=...&REGON=...&
	//Zwraca:
	//RE=block_department&STATUS=done&
	//lub
	//RE=block_department&STATUS=refused&CP=<powod odmowy>&
	if(strcmp(value, "block_department")==0) {
	return block_department(in, out);
	}
	

	//pobieranie danych departamentu przez (DEP, NIP/REGON)
	//OP=get_dep_data&DEP=..&UID32=...&
	//Zwraca:
	//   RE=get_dep_data&STATUS=done&UID32=...&EUID=..&DEP=...
	//   &LIP=...&PUID=...&PORTP=..&PORTQ=...&NODES=..
	//   &DATE=..&
	// lub
	// RE=get_dep_data&STATUS=refused&CP=<powod odmowy>& 
	if(strcmp(value, "get_dep_data")==0) {
	return get_dep_data(in, out);
	}






	// --- rejestracja uzytkownika ---
	
	// dodaje  admina/usera - "admin registration" 
	// OP=add_usr&UID32=..&EUID=..&UIDP=null&EUIDP=null
	// &NAME=<imie i nazwisko>&PESEL=...&DEP=...&STAT=admin&
	// nie zapisuje w UIDC RANGE oraz ACT (tylko w UIDL)
	// dopisuje: RANGE=1111111&ACT=A&
	//
	// Odpowiedz:
	//   RE=add_usr&STATUS=done&UID32=..&EUID=..&UIDP=...&EUIDP=...
	//   &NAME=<imie i nazwisko>&
   //   PESEL=...&DEP=...&STAT=admin&RANGE=...&ACT=A&DATE=..&
   //   lub
   //   RE=add_usr&STATUS=refused&CP=<powod odmowy>&

	// Nowy user (nie admin) 
	// OP=add_user&UID32=..&EUID=..&UIDP=null&EUIDP=null
	// &NAME=<imie i nazwisko>&PESEL=...&DEP=...&STAT=user&
	// RANGE=...&ACT=<A/B>&
	// nie zapisuje w UIDC: RANGE oraz ACT (tylko w UIDL)
	// (jedynie odsyla takie jak byly podane w stringu
	//
	// Opowiedz:
	//   RE=add_user&STATUS=done&UID32=..&EUID=..&UIDP=...&EUIDP=...
	//   &NAME=<imie i nazwisko>&
   //   PESEL=...&DEP=...&STAT=<user/admin>&
   //   RANGE=...&ACT=<A/B>&DATE=...&
   //
   //W przypaadku odmowy odpowidz w obu przypadkach jest:
   //RE=add_user&STATUS=refused&
	if(strcmp(value, "add_usr")==0) {
	return add_usr(in, out);
	}




	// --- check user w UID32BASE ---
	// OP=check_user&UID32=..&EUID=..&UIDP=..&EUIDP=..&
	// Zwraca:
	// 	OP=check_user&STATUS=done&
	// 	lub
	// 	OP=check_user&STATUS=refused&CP=<powod odmowy>&
	if(strcmp(value, "add_usr")==0) {
	return add_usr(in, out);
	}
	



	//--- blokowanie uzytkownika z poziomu UIDC ---
	
	//z poziomu admina UIDC
	//nalezy podac PESEL
	//OP=block_user_by_central_admin&PESEL=...& 
	//RE=block_user_by_central_admin&STATUS=done&
	//lub
	//RE=block_user_by_central_admin&STATUS=refused&
	if(strcmp(value, " block_user_by_central_admin")==0) {
	return  block_user_by_central_admin(in, out);
	}



	// --- blokowanie uzytkownika z poziomu UIDL ----
	
	//(z poziomu admina UIDL - ogolenie serwera UIDL)
	//OP=block_user&&UID32=..&EUID=..&UIDP=...&EUIDP=...
	// &NAME=<imie i nazwisko>&PESEL=...&DEP=...&STAT=admin&
	// nie zapisuje w UIDC RANGE oraz ACT (tylko w UIDL)
	// dopisuje: RANGE=1111111&ACT=A&DATE=...&
	//Opowiedz
	//RE=block_user&STATUS=done&
	//lub
	//RE=block_user&STATUS=refused&CP=<powod odmowy>&
	if(strcmp(value, "block_user")==0) {
	return  block_user(in, out);
	}
	


	// --- dodawanie konta PESEL do mapy kont ---

	// UIDL przesyla jesli utworzone zostanie nowe konto PESEL
	// tylko dla pesel zgodne z formula (124.., N123... RN123.., RS123..)
	// dane dodawane sa do pliku PESEL_OBJ.q 
	// OP=add_pesel_obj&PESEL=..&UID32=..&DEP=..&
	// Zwraca:
	// 	OP=add_pesel_obj&STATUS=done&
	// 	lub w przypadku bledu
	// 	OP=add_pesel_obj&STATUS=refused&
	if(strcmp(value, "add_pesel_obj")==0) {
	return  add_pesel_obj(in, out);
	}



	// --- odczyt PESEL z mapy kont --- 

	//pobieranie liczby linii rejestracji danego konta PESEL (OBJ)
	//OP=get_nlines_pesel&PESEL=...&
	//Odpowiedz:
	//RE=get_nlines_pesel&NLINES=<liczba linii>&
	//jesli brak zatrejestrowanego PESEL to NLINES=0&
	if(strcmp(value, "get_nlines_pesel")==0) {
	return  get_nlines_pesel(in, out);
	}


	//pobiera line o podanym numerze (dla OBJ)
	//OP=get_line_pesel_obj&PESEL=...&NLINE=<numer linii>&
	//Odpowiedz:
	//RE=get_line_pesel_obj&STAT=done&PESEL=...&UID32=...&DEP=..&
	//lub
	//RE=get_line_pesel_obj&STAT=done&&STATUS=refused&CP=<powod bledu>&
	if(strcmp(value, "get_line_pesel_obj")==0) {
	return  get_line_pesel_obj(in, out);
	}

	

	//pobiera node data na ktorym jest zarejestrowany konto
	//poprzez UID32/DEP
	//OP=get_node&UID32=...&DEP=..&
	//Zwraca:
	//RE=get_node&STATUS=done&DEP=..&NAME=..&DEP=...&NIP=..
	//&REGON=...&LIP=...&PUID=...&PORTP=..&PORTQ=..&
	//lub jesli byl blad
	//RE=get_node&STATUS=refused&CP=<powod odmowy>&
	if(strcmp(value, "get_node")==0) {
	return  get_node(in, out);
	}



	//--- dodaje i zmienia (static/var) ip adres UIDL node ---
	//OP=add_ip_node&UID32=..&IPNODE=..&
	//RE=add_ip_node&STATUS=done&
	//lub
	//RE=add_ip_node&STATUS=refused&
	if(strcmp(value, "add_ip_node")==0) {
	return  add_ip_node(in, out);
	}
	


	// --- version ---
	
	//OP=versionUIDC&
	//RE=versionUIDC&VER=..&SYS=...&
	//lub
	//RE=versionUIDC&VER=null&SYS=null&CP=<powod bledu>&
	if(strcmp(value, "versionUIDC")==0) {
	return versionUIDC(in, out);
	}



	//--- restore struktury z plikow LIST ---
	
	//odbudowanie struktury z backup (w katalogu LIST)
	//OP=restore_files_local&
	//RE=restore_files_local&STATUS=<done/refused>CP=<powod odmowy>&
	if(strcmp(value, "restore_files_local")==0) {
	return restore_files_local(in, out, ip_client);
	}


	// --- zmiana portu meserverUIDC ---
	
	//pobiera IP/PORT UIDC z configu UIDC
	//OP=get_uidc_config&
	//RE=get_uidc_config&PORTUIDC=...&
	//Jesli blad to zwraca:
	//RE=get_uidc_config&PORTUIDC=null&
	if(strcmp(value, "get_uidc_config")==0) {
	return get_uidc_config(in, out);
	}


	//zmienia IP/PORT UIDC w pliku konfiguracyjnym UIDC
	//OP=chg_uidc_config&PORTUIDC=...&
	//RE=chg_uidc_config&STATUS=<done/refused>CP=<powod odmowy>&
	//lun w przypadku bledu
	//RE=chg_uidc_config&STATUS=<done/refused>CP=<powod odmowy>&
	if(strcmp(value, "chg_uidc_config")==0) {
	return chg_uidc_config(in, out, ip_client);
	}




	// --- logfile admina ---
	//zapisuje ostatnie logowanie admina
	//OP=log_adm&PESEL=...&NICK=..&
	//RE=log_adm&STATUS=done&
	//lub
	//RE=log_adm&STATUS=refused&CP=<powod odmowy>&
	if(strcmp(value, "log_adm")==0) {
	return log_adm(in, out);
	}





    strcpy(out,"I love you.");
    return -2;	
}
//-------------------------------- END Analizator -----------------------------




///////////////////////////////////////////////////////////////////////////////
//-------------------------------- INTERFACE ----------------------------------
///////////////////////////////////////////////////////////////////////////////
int executor(char*input, const char*ip_client) {

   int ret; 

   char txt[HEADSIZE];

   //fprintf(stdout,"Client's IP : %s\n", ip_client); //<----------- test
   //fflush(stdout); //<-------------------------------------------- test	  

   //--- decoder ---
   decodeV1(input, 0, txt);//decoder

   /* --- shows task q-string on the screen ---*/
   if(test_mode) {
	fprintf(stdout,"EXEC REC[2]: %s\n", txt);
	fflush(stdout);		
   }

       
	/* --- go to anslisis of task --- */
	ret = analizator(txt, txt, ip_client);
        if(ret==-2) {
            if(test_mode) printf("TEST: I love you.\n");
            strcpy(input, "I love you.");
            return 0;
        }


   /* --- shows task q-string on the screen ---*/
   if(test_mode)  {
	fprintf(stdout,"EXEC OUT[2]: %s\n", txt);
	fflush(stdout);		
   }

   //--- encoder ---
   codeV1(txt, 0, input);

   return ret;
}
///////////////////////////////////////////////////////////////////////////////
//-------------------------------- INTERFACE ----------------------------------
///////////////////////////////////////////////////////////////////////////////

