///////////////////////////////////////////////////////////////////////////////
//									     
//		GENERATOR UID32 ORAZ EUID (LONG UID64)			     
//	                   LUID = UID32 + EUID
//	               		   oraz
//	               	    CODE (tmp key32)
//
//
//	(Uzycie pocztkowych trzech liter gnerowanych losowo dlaje
//	rozklad dostepu do rejestru (struktury katalogow: A/B/C/...)
//	ok 11 linii do analizy dla 200 000 rejestrcji UID)
//	
///////////////////////////////////////////////////////////////////////////////




#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>



//UID32_TRUE/EUID_TRUE
//typy gnerowanych znakow (przez true_random_generator(..))
// 0  => generuje dowolne liczby 0-255
// 1  => generuje tylko cyfry
// 2  => generuje tylko duze litery
// 3  => generuje tylko male litery
// 4  => generuje znaki z I strony ASCII bez znakow serujacych
#define TRUE_UID  1 
#define TRUE_EUID 3 //rozmaite znaki z I strony ASCII (bez sterujacych)





//--- Kreatory ---

//generuje UID32/euid32
int gen_UID64T(char*luid, char*euid, int format);

//generuje tylko EUID (na wejsciu podajemy stary euid dla eliminacji powtorki)
int gen_EUID_TRUE(char*euid);

//generuje CODE (tmp key32) (mozna eliminowac powtorzenie podajac stary code)
int gen_CODE_TRUE(char*code);

//kod startowy przy pierwszej rejestracji UIDL
int start_CODE(char*code); 

//--- END Kreatory --- 






//-----------------------------------------------------------------------------
//--------------------------------- Pomocnicze --------------------------------
//type_flg:
// 0  => generuje dowolne liczby 0-255
// 1  => generuje tylko cyfry
// 2  => generuje tylko duze litery
// 3  => generuje tylko male litery
// 4  => generuje znaki z I strony ASCII bez znakow serujacych
int true_random_generator(char*str, int byte_count, int type_flg){
	int i;
	unsigned char data[64];
	FILE *fp;
	fp = fopen("/dev/urandom", "r");
	if(fp==NULL) return -1;
	fread(&data, 1, byte_count, fp); 
	fclose(fp);

	//generuje dowolne liczby z zakresu 0..255
	if(type_flg==0){
		for(i=0;i<byte_count;i++) str[i] = data[i];
	str[i]='\0';
	return 0;
	}
	//generuje same cyfry
	if(type_flg==1){
		for(i=0;i<byte_count;i++) str[i] = data[i]%10 + 48;
	str[i]='\0';
	return 0;
	}
	//duze litery
	if(type_flg==2) {
		for(i=0;i<byte_count;i++) str[i] = data[i]%26 + 65;
	str[i]='\0';
	return 0;
	}
	//male litery
	if(type_flg==3) {
		for(i=0;i<byte_count;i++) str[i] = data[i]%26 + 97;
	str[i]='\0';
	return 0;
	}
	//rozmaite znaki
	if(type_flg==4) {
		for(i=0;i<byte_count;i++) str[i] = data[i]%93 + 33;
	str[i]='\0';
	return 0;
	}
return -1;
}


//generuje start kode w postaci XXXX-XXXX-XXXX-XXXX
int gen_start_code(char*code) {

	char str[5];
	int ret;

	ret = true_random_generator(str, 4, 2);
	if(ret < 0) return -1;
	strcpy(code, str);
	strcat(code, "-");
	
	ret = true_random_generator(str, 4, 2);
	if(ret < 0) return -1;
	strcat(code, str);
	strcat(code, "-");

	ret = true_random_generator(str, 4, 2);
	if(ret < 0) return -1;
	strcat(code, str);
	strcat(code, "-");

	ret = true_random_generator(str, 4, 2);
	if(ret < 0) return -1;
	strcat(code, str);
	strcat(code, "-");

	ret = true_random_generator(str, 4, 2);
	if(ret < 0) return -1;
	strcat(code, str);

	return 0;
}


int timer(char*ssek, char*nsek){
	struct timespec ts;
	int ret;
	ret = clock_gettime(CLOCK_REALTIME, &ts);
	if(!ret) {
	sprintf(ssek,"%ld",ts.tv_sec);
	sprintf(nsek,"%ld",ts.tv_nsec);
	} else {
		strcpy(ssek,"NULL");
		strcpy(nsek,"NULL");
		}
	return ret;
}


void gen_chars(char*ch){
	int j,jp;
	jp = (int)(rand()/(RAND_MAX +1.0)*3);
	switch(jp){
		case 0: 
		j = (int)(rand()/(RAND_MAX +1.0)*10);
		j+=48;
		break;
		case 1:
		j = (int)(rand()/(RAND_MAX +1.0)*26);
		j+=65;
		break;
		case 2:
		j = (int)(rand()/(RAND_MAX +1.0)*26);
		j+=97;
		break;
	}
	ch[0]=j;
	ch[1]='\0';
}
//-------------------------------- END Pomocnicze -----------------------------
//-----------------------------------------------------------------------------




//-----------------------------------------------------------------------------
//-------------------------- GENERATOR UID32/EUID NORMAL ----------------------
//--- NORMAL UID32 ---
int gen_UID32(char*uid){
	time_t tt, cr;
	cr=time(&tt);
	srand((unsigned int)cr);
	char ui[40];
	char ssek[20];
	char nsek[20];
	int i;
	int ret;
	ret = timer(ssek,nsek);
	if(!ret) {
	strcpy(ui,ssek);
	strcat(ui,nsek);
	} else {
		strcat(uid,"NULL");
		return -1;
		}
	if(strlen(ui)<32) {
	for(i=0; i<32; i++) {gen_chars(ssek); uid[i]=ssek[0];}
	uid[i]='\0';
	strcpy(uid,ui);
	for(i=0;i<32;i++) if(uid[i]=='\0'){gen_chars(ssek);uid[i]=ssek[0];}
	} else {
	for(i=0;i<32;i++) uid[i]=ui[i];
	uid[i]='\0';
	}
return 0;
}


// --- NORMAL EUID---
void gen_EUID(char*uid){
	char ssek[5];
	int i;
	for(i=0; i<32; i++) {gen_chars(ssek); uid[i]=ssek[0];}
	uid[i]='\0';
}
//---------------------- END GENERATOR UIS32/EUID NORMAL ----------------------
//-----------------------------------------------------------------------------




//-----------------------------------------------------------------------------
//------------------------- TRUE UID32/EUID GENERAOR  -------------------------
//true CODE (dla tmp_UID)
int gen_CODE_TRUE(char*code) {
	char data[35];
 	char ei[35];
	char lett[5];
	strcpy(ei,code);
	int j,i=0;
	while(i<20) {
	if(true_random_generator(data, 32, TRUE_EUID)==-1) //4-rozne znaki
		{strcpy(code,"NULL"); return -1;}
	//trzy litery beda rozpoczynac UID32 
	if(true_random_generator(lett, 3, 2)==-1) //2 -duze litery
		{strcpy(code,"NULL"); return -1;}
		for(j=0;j<3;j++) data[j]=lett[j];//wkleja trzy litery	
	if(strcmp(ei,data)!=0) {strcpy(code,data); return 0;}	
	i++;
	}
	return -1;	
}


//true EUID
int gen_EUID_TRUE(char*euid) {
	char data[35];
 	char ei[35];
	strcpy(ei,euid);
	int i=0;
	while(i<20) {
	if(true_random_generator(data, 32, TRUE_EUID)==-1) //4-rozne znaki
		{strcpy(euid,"NULL"); return -1;}
	if(strcmp(ei,data)!=0) {strcpy(euid,data); return 0;}	
	i++;
	}
	return -1;	
}


//true UID32
int gen_UID32_TRUE(char*uid) {
	char data[35];
	char lett[5];
	char ssek[20];
	char nsek[20];
	char ui[40];
	int i;
	int ret;
	if(true_random_generator(data, 32, TRUE_UID)==-1) //1- tylko liczby
		{strcpy(uid,"NULL"); return -1;}
	//trzy litery beda rozpoczynac UID32 
	if(true_random_generator(lett, 3, 2)==-1) //2 -duze litery
		{strcpy(uid,"NULL"); return -1;}	
	ret = timer(ssek,nsek);
	if(!ret) {
	strcpy(ui,ssek);
	strcat(ui,nsek);
	} else {
		strcat(uid,"NULL");
		return -1;
		}
	if(strlen(ui)<32){
		 for(i=0;i<3;i++) data[i]=lett[i];//wkleja trzy litery
		 for(i=3;i<(int)strlen(ui);i++) data[i] = ui[i];
		} else {
		for(i=0;i<3;i++) data[i]=lett[i];//wkleja trzy litery
		for(i=3;i<32;i++) {data[i] = ui[i];} data[i]='\0';
		}
	strcpy(uid,data);
	return 0;
}
//----------------------- END TRUE UID32/EUID GENERATOR -----------------------
//-----------------------------------------------------------------------------



//-----------------------------------------------------------------------------
//------------------------- FORMATOWANIE "-" UID32/EUID ----------------------- 
//formatowanie
void format_UID32(const char*uid_in, char*uid) {
	int k,i,j=0;
	char u[40];
	char g[8][6];

	strcpy(u,uid_in);

	for(j=0;j<8;j++) for(i=0;i<6;i++) g[j][i]='\0';

	//123e4567-e89b-12d3-a456-4266 5544 0000 
	for(j=0; j<8; j++) {
	    k=0;
	    for(i=j*4; i<(j*4)+4; i++) {g[j][k]=u[i];k++;}
		}
	strcpy(uid,g[0]);
	strcat(uid,g[1]);
	strcat(uid,"-");
	strcat(uid,g[2]);
	strcat(uid,"-");
	strcat(uid,g[3]);
	strcat(uid,"-");
	strcat(uid,g[4]);
	strcat(uid,"-");
	strcat(uid,g[5]);
	strcat(uid,g[6]);
	strcat(uid,g[7]);	
}
//------------------------ END FORMATOWANIE UID32/EUID ------------------------
//-----------------------------------------------------------------------------




//=============================================================================
//-------------------------- GENEROWANIE UID32 & EUID ------------------------- 
//=============================================================================
//---NORMAL GENERATOR (srand(clock)/renad) ---
//generowanie LUID dla sd card/USB
//deklracja:
//char luid[32]
//char euid[32]
//format=0 bez separatorow '-'
//format=1 z separatorem
int gen_UID64(char*luid, char*euid, int format){
	if(gen_UID32(luid)==-1) return -1;//UID32
	if(format) format_UID32(luid,luid);
	gen_EUID(euid);
	if(format) format_UID32(euid,euid);
	return 0;
}


//kod startowy przy pierwszej rejestracji UIDL (kod rejestracji)
int start_CODE(char*code) {
	if(gen_start_code(code) < 0) return -1;
	return  0;
}

//--- TRUE GENERATOR ---
//z uzyciem true random numbers
//przy euid mozna prowadzic stary EUID aby wykluczyc jego powtorzenie
//tzn. strcpy(euid,EUID); //jesli nie ma separatorow tzn. format=0
int gen_UID64T(char*luid, char*euid, int format) {
	if(gen_UID32_TRUE(luid)==-1) return -1;//UID32
	if(format) format_UID32(luid,luid);
	gen_EUID_TRUE(euid);
	if(format) format_UID32(euid,euid);
	return 0;
}
//=============================================================================



/*
int main(){
char luid[40];
char euid[40];
char code[40];
gen_UID64T(luid, euid, 0);
//strcpy(code,euid);
//gen_CODE_TRUE(code);
//gen_UID32_TRUE(code);
gen_start_code(code);
printf("UID32 = %s\n",luid);
printf("EUID  = %s\n",euid);
printf("CODE  = %s\n",code);

return 0;
}*/
