///////////////////////////////////////////////////////////////////////////////
//
//                    Numerator konta specjalnego PESEL
//
//                              (JPW-2019)
//
//
///////////////////////////////////////////////////////////////////////////////



#include <stdio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>


#define RS_NUMBER "DISK/rs_last_number.txt"
#define NUMERATOR "numerator"






//pobiera ostatni wpis numeratora 
int get_last_number(char*nst) {
	
	char *p;

	FILE*fd = fopen(RS_NUMBER, "r");
	if(fd == NULL) 	{
		strcpy(nst, "null");
		return -1;
	}

	fgets(nst, 20, fd);
	fclose(fd);

	p = strchr(nst, '\n');
	if( p != NULL) *p = '\0';

	return 0;
}



//zapisuje ostatni numer numeratora
int wtrite_last_number(const char*nst) {

	FILE*fd = fopen(RS_NUMBER, "w");
	if(fd == NULL) 	return -1;

	fprintf(fd, "%s\n", nst);
	fflush(fd);

	fclose(fd);

	return 0;
}



//sprawdza czy nie dziala inna instacja rs_numerator
//moze dzialac tylko jedna instancja tej aplikacji
//w momencie wykonywania operacji
int check_other_instance(void) {

	char st[512];
	char pd[512];
	char *p;	

	strcpy(st, "pidof ");
	strcat(st, NUMERATOR);

	FILE*fp = popen(st, "r");
	if(fp == NULL) return 0;

	strcpy(st, "null");
	fgets(st, 512, fp);
	pclose(fp);

	p = strchr(st, '\n');
	if(p != NULL) *p = '\0';

	strcpy(pd, st);

	p = strchr(pd, ' ');
	if(p!=NULL) *p='\0';

	if(strlen(pd) == strlen(st)) {
		return 1;
	}

	return 0;
}



//tworzy nowy numer RS xxx xxx xxx
int create_rs_number(char*new_rs_number) {

	 char nr[20];
	 char nrs[20];
	 int n, i;

	 if(get_last_number(nr) <0) {
		strcpy(new_rs_number, "null [1]");
		return -1;
	 }	

	//jesli dlugsc numeru jest rozna od 11 znakow (konto PESEL)
	if(strlen(nr) != 11) {
		strcpy(new_rs_number, "null [2]");
		return -1;		
	}

	//sprawdza czy string zaczyna sie od "RS"
	if(nr[0] !='R' && nr[1] != 'S') {
		strcpy(new_rs_number, "null [3]");
		return -1;	
	}

	 memcpy(nrs, nr+3, 10); //kopiuje razem z '\0'

	 n = atoi(nrs);
	 if(n < 100) {
		strcpy(new_rs_number, "null [4]");
		return -1;		
	}

	n++;

	sprintf(nr, "%d", n);

	n = (int)strlen(nr);

	for(i=0; i<9-n; i++) {
		*(nrs+i) = '0';
	}

	*(nrs+i) = '\0';
	strcat(nrs, nr);

	strcpy(new_rs_number, "RS");

	strcat(new_rs_number, nrs);

	if(wtrite_last_number(new_rs_number) < 0) {
		strcpy(new_rs_number, "null [5]");
		return -1;	
	}

 	return 0;
}


//inicjuje pliki z numerem "RS000000100"
int create_init(void) {

	int ret;
	char nst[20] = "RS000000100";
	struct stat sb;

	//nie zaklada pliku jesli plik już jest w katalogu DISK
	if(stat(RS_NUMBER, &sb) == 0) return -1; 

   ret = wtrite_last_number(nst);

	return ret;
}




int main(int argc, char**argv) {


	if(argc == 2) {
		if(strcmp(argv[1],"-i") ==0 ) {
			if(create_init() < 0) 
			printf("\n  Init Special RS number file cannot be created!!!\n\n");
		} 
		else 
			printf("\n  Init Special RS number file cannot be created!!!\n\n");

		return 0;
	}


	char new_rs_number[20];
	char *p;

	if(!check_other_instance()) {
		printf("null [1]\n");
		return 0;
	}

	create_rs_number(new_rs_number);
	p = strstr(new_rs_number, "null");
	if(p != NULL) strcpy(new_rs_number, "null");


	printf("%s\n", new_rs_number);


	return 0;
}
