///////////////////////////////////////////////////////////////////////////////
//
//			Aplikacja zastrzymujaca dzialanie
//			        CENTRAL SEREVER
//				     ver 0.2
//
//				
//  Kompilacja: make
//
//////////////////////////////////////////////////////////////////////////////


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include "select_value.c"


#define CONFIG_FILE "mserverUIDC.config"





int chk_pid_server(const char*server_name) {

     char rep[1024]="null";
     FILE*fp = popen(server_name,"r");
     if(fp==NULL) return 0;
     fgets(rep,1024,fp);
     pclose(fp);
     if(strcmp(rep, "null")==0) return 0;
     return 1;
}




//odczytuje z configu punkty montowania
//mp_uid   - punkt montowania UID32BASE
//mp_pesel - punkt montowania PESEL
//mp_list  - punkt montowania LIST
//mp_start - punkt motowania START
int read_config_file(char*mp_uid, char*mp_pesel, char*mp_list, char*mp_start) {

	char str[256];
	char*p;
	
	FILE*fd = fopen(CONFIG_FILE, "r");
	if(fd == NULL) return -1;
	
	while(fgets(str, 256, fd) != NULL) {
		p = strstr(str, "UIDBASE");
		if(p != NULL) {
			select_value(str, "UIDBASE", mp_uid);
			if(strcmp(mp_uid, "NULL") == 0) strcpy(mp_uid, "null");
		}

		p = strstr(str, "PESELBASE");
		if(p != NULL) {
			select_value(str, "PESELBASE", mp_pesel);
			if(strcmp(mp_pesel, "NULL") == 0) strcpy(mp_pesel, "null");
		} 
		p = strstr(str, "LISTBASE");
		if(p != NULL) {
			select_value(str, "LISTBASE", mp_list);
			if(strcmp(mp_list, "NULL") == 0) strcpy(mp_list, "null");
		}
		p = strstr(str, "STARTBASE");
		if(p != NULL) {
			select_value(str, "STARTBASE", mp_start);
			if(strcmp(mp_start, "NULL") == 0) strcpy(mp_start, "null");
		}

 
	}	
	fclose(fd);
	return 0;
}



//zamiast system()
int exec_system(const char*process) {
	FILE*fp = popen(process, "r");
	if(fp == NULL) return -1;
	pclose(fp);
	return 0;
}




//sprawdza czy partycja jest zamontowana
int check_mounted_disk(const char*disk) {

    char*s = "df -h";
    char *p;
    char buf[256];

    FILE*fp = popen(s, "r");
    if(fp == NULL) return -1;

    int ch = 0;
    while(fgets(buf, 256, fp) != NULL) {
	p = strstr(buf, disk);
	if(p != NULL) ch = 1;
    }

    pclose(fp);
    return ch;
}




//odmontowuje dyski
int umount_base(void) {

	int ret;
	char mp_uid[20];
	char mp_pesel[20];
	char mp_list[20];
	char mp_start[20];
	char st[80];


	ret = read_config_file(mp_uid, mp_pesel, mp_list, mp_start);
	if(ret < 0) {
		printf("\n ERROR: cannot read file: %s\n\n", CONFIG_FILE);
		return -1;
	}

	//sprawdza i odmontowuje mp_uid (UID32BASE)
	if(strcmp(mp_uid, "null") != 0) {
		//sprawdza czy partycja jest zamnotowana
      	if(check_mounted_disk(mp_uid)) {
			strcpy(st, "umount ");
			strcat(st, mp_uid);
			exec_system(st);
		}
	} 

	//sprawdza i odmontowuje mp_list (LIST)
	if(strcmp(mp_list, "null") != 0) {
		if(strcmp(mp_list, mp_uid) !=0) {
			if(check_mounted_disk(mp_list)) {
				strcpy(st, "umount ");
				strcat(st, mp_list);
				exec_system(st);
			}
		}
	}

	//sprawdza i odmontowuje mp_pesel (PESEL)
	if(strcmp(mp_pesel, "null") != 0) {
		if(strcmp(mp_pesel, mp_uid) !=0) {
			if(strcmp(mp_pesel, mp_list) != 0) {
				if(check_mounted_disk(mp_pesel)) {
					strcpy(st, "umount ");
					strcat(st, mp_pesel);
					exec_system(st);
				}
			}
		}
	}


	//sprawdza i odmontowuje mp_start (START)
	if(strcmp(mp_pesel, "null") != 0) {
		if(strcmp(mp_pesel, mp_uid) !=0) {
			if(strcmp(mp_pesel, mp_list) != 0) {
				if(strcmp(mp_start, mp_list) != 0) {
					if(check_mounted_disk(mp_start)) {
						strcpy(st, "umount ");
						strcat(st, mp_pesel);
						exec_system(st);
					}
				}
			}
		}
	}



	return 0;
}







int main() {


	if(getuid() != 0) {
		printf("\n\n Login as root!\n\n");
		return 0;
 	}	


int i;


//stop daemona sync czasu
system("sudo pkill sync_time");
i = 0;
while(chk_pid_server("pidof sync_time") && i<10) {
	sleep(1);
	i++;
}

if(!chk_pid_server("pidof sync_time")) {
	 printf("\n ... sync_time is stopped ...\n");
} else printf("\n ... sync_time still works ...\n");



//stop serwer systemu centralnego
system("sudo pkill mserverUIDC");
i = 0;
while(chk_pid_server("pidof mserverUIDC") && i<10) {
	sleep(1);
	i++;
}
if(!chk_pid_server("pidof mserverUIDC")) {
	printf(" ... mserverUIDC is stopped ...\n\n");
} else  printf(" ... mserverUIDC still works ...\n\n");


if(!chk_pid_server("pidof mserverUIDC")) {
	umount_base();
}



return 0;

}
