/******************************************************************************
 *				ARCHI-CLIENT-SERVER
 *			   	     client-UID
 * 				      ver 0.1
 *
 * NOTE: aplikacja klienta do komunikacji pomiedzy klientem a Serv UID32
 *
 *  uzycie:
 *  client_U("10.0.0.10", 8809, str_input, str_out);
 *
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 
#include <arpa/inet.h>
#include <time.h>
#include <errno.h>

//#include "clientUID.h" //header 


//#define HEADSIZE 512
//#define BUFSIZE HEADSIZE+512 
time_t timeout_seconds=10;
long timeout_microsec=100;

#define PORT_TCPIP_UID 8809 //sztywny port TCP

#ifndef CODEPAS 
#define CODEPAS
#include "code_pass.c"
#endif


//header
int client_U(char*server_address, int port, char*str_input, char*str_out);
int clientUID(char *adres_ip, char *str_to_send, char *server_reply);



///////////////////////////////////////////////////////////////////////////////
//---------------------------- SEND/RECV MESSAGE ------------------------------
///////////////////////////////////////////////////////////////////////////////
//connection socket function 
int op_message(const char*ip_addr, int port, 
                  char*message, int test) {

    char buffer[BUFSIZE];
    int sockfd, n;
    int error = 0;
    fd_set  rset, wset;
    socklen_t   len = sizeof(error);
    struct sockaddr_in serv_addr;
    struct timeval timeout;      
    timeout.tv_sec = timeout_seconds; //TIMEOUT_SEC; //0;
    timeout.tv_usec = timeout_microsec;// TIMEOUT_USEC; //100000=0.1s

    //if message is too long
    if(strlen(message)>HEADSIZE-1) {
       strcpy(message, "null");
       return -1;
    }

    //opens socket (in nonblocking mode)
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if(sockfd < 0) {
      if(test) printf("Error opening socket on port %d\n", port);
      strcpy(message, "null");
      return -1;
    }

    //set tmeout for recv()
    if(setsockopt(sockfd, SOL_SOCKET, SO_RCVTIMEO, (char*)&timeout,
                   sizeof(timeout)) < 0) {
      if(test) printf("Error: test_nodes setsockopt failed [1]\n");
      strcpy(message, "null"); 
      close(sockfd);  
      return -1;
    }
    //set timeout for send()
    if(setsockopt(sockfd, SOL_SOCKET, SO_SNDTIMEO, (char*)&timeout,
                  sizeof(timeout)) < 0) {
      if(test) printf("Error: test_nodes setsockopt failed [2]\n");
      strcpy(message, "null");
      close(sockfd);
      return -1;
    }

    memset((char*)&serv_addr, 0, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = inet_addr(ip_addr);
    serv_addr.sin_port = htons(port);

    //clear out descriptor sets for select
    //add socket to the descriptor sets
    FD_ZERO(&rset);
    FD_SET(sockfd, &rset);
    wset = rset; 

    //timeout set again if was changed
    timeout.tv_sec = timeout_seconds; //TIMEOUT_SEC; //0;
    timeout.tv_usec = timeout_microsec;//TIMEOUT_USEC; //100000=0.1s

    //set socket in nonblocking mode
    n = fcntl(sockfd, F_SETFL, fcntl(sockfd, F_GETFL, 0) | O_NONBLOCK);
    if (n == -1){
       if(test) perror("[1] fcntl: ");
       close(sockfd);
       strcpy(message, "null");
       return -1;
    }

    if((n=connect(sockfd, (struct sockaddr*)&serv_addr,
               sizeof(serv_addr))) < 0) {
      if (errno != EINPROGRESS) {
         if(test) perror("connect:");
         close(sockfd);
         strcpy(message, "null");
         return -1;
      }
    }
    //connection succeeded right away
    if(n==0) goto label_end; 


    //waiting for connect to complete now
    if((n = select(sockfd + 1, &rset, 
        &wset, NULL, &timeout)) < 0) {
      if(test) perror("select:");
      strcpy(message, "null");
      close(sockfd);
      return -1;
    }
    if(n==0){   //when timeout
       errno = ETIMEDOUT;
       strcpy(message, "null");
       close(sockfd);
       return -1;
    }

    //a positivite return so a descriptor is ready
    if(FD_ISSET(sockfd, &rset) || FD_ISSET(sockfd, &wset)) {
      if(getsockopt(sockfd, SOL_SOCKET, SO_ERROR, &error, &len) < 0) {
         close(sockfd);
         return -1;
      }
    } 
    else {
      strcpy(message, "null");
      close(sockfd);
      return -1;
    }

    if(error){  //check  a socket error
      errno = error;
      strcpy(message, "null");
      close(sockfd);
      return -1;
    }

label_end:
    //set socket in blocking mode
    n = fcntl(sockfd, F_SETFL, fcntl(sockfd, F_GETFL, 0) & ~O_NONBLOCK);
    if (n == -1){
       if(test) perror("[2] fcntl: ");
       close(sockfd);
       strcpy(message, "null");
       return -1;
    }

    codeV1(message, 0, buffer);
    n = write(sockfd,buffer,BUFSIZE);
    //printf("[test_nodes write] n=%d\n", n);
    if(n < 0) {
      if(test) printf("Error writing to socket\n");
      close(sockfd);
      strcpy(message, "null");   
      return -1;
    }
    memset(buffer,0, BUFSIZE);
    //n = read(sockfd, buffer, BUFSIZE);
    n = recv(sockfd,buffer, BUFSIZE, MSG_WAITALL);
    if(n < 0) {
       if(test) printf("Error reading from socket\n");
       close(sockfd);
       strcpy(message, "null");
       return -1;
    }
      
    if(strcmp(buffer,"I love you.")==0) {
       strcpy(message,"null");
       close(sockfd);
       return -1;
    } 
    else decodeV1(buffer,0, message);

    close(sockfd);

    return 0;
}//end message
///////////////////////////////////////////////////////////////////////////////
//------------------------ END SEND/RECV MESSAGE ------------------------------
///////////////////////////////////////////////////////////////////////////////



int client_U(char*server_address, int port, char*str_input, char*str_out) {

   int ret;
   char message[HEADSIZE];

   strcpy(message, str_input);

   ret = op_message(server_address, port, message, 1);

   strcpy(str_out, message);

   return ret;
}


int clientUID(char *adres_ip, char *str_to_send, char *server_reply) {

   return client_U(adres_ip, PORT_TCPIP_UID, str_to_send, server_reply); 
}
