///////////////////////////////////////////////////////////////////////////////
//
//
//	            	                  Client MYIP
//	            	                  (JPW-2019)
//	            	                    ver 0.1
//
//
//
///////////////////////////////////////////////////////////////////////////////

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#ifndef SELECT 
#define SELECT
#include "SRC/select_value.c" 
#endif


#define DELAY_INIT 3 //sec
#define DELAY_VAR 600 //co 10 min. sprawdza IP (WAN) UIDL 


#include "UID_MYIP_CLIENT/clientMYIP.h"
#include "UID_MYIP_CLIENT/clientUID.h"


#define PATH_SIZE 512 //dlugosc stringu path+filename .../MYIPBase
#define CONFIG_FILENAME "mserverUIDL.config"


//polozenie bazy UID dla generowanych UID32 w mserverUIDL.config
#define BASE_UID "DISK/UID32BASE" //path do bazy UID32
char uid32base[PATH_SIZE]=BASE_UID;


//nazwa pliku (var/stat)
#define VARSTAT "varstat.q" 	//VARSTAT=<var/static>&


//ip, port serwera MYIP (znajduja sie w mserverUIDL.config)
char ipaddress[20] = "127.0.0.1"; //adress serwera
int port = 8750;  

//ip serwera Centralnego UIDC
char central_ip[20] = "127.0.0.1";
//port serwera Centralnego UIDC
int port_central = 8809;


//sledzony adres IP serwera UIDL (zaleznie od flag stat/var)
char ip_UIDL[20] ="null";





///////////////////////////////////////////////////////////////////////////////
//--------------------------- PATH+nazwa bazy MYIPBase -------------------------
///////////////////////////////////////////////////////////////////////////////
//Odczyt pliku konfiguracyjnego
int read_config(void) {

	int i;
	int ch;

	char st[PATH_SIZE];
	char out[PATH_SIZE];
	char *p;

	strcpy(uid32base, "null");

	FILE*fd = fopen(CONFIG_FILENAME,"r");
	if(fd==NULL) {
			printf("\n  Error: no config file\n\n");
			return -1;
	}
	while(fgets(st,PATH_SIZE,fd)!=NULL) {

		p = strstr(st, "UIDBASE");
		if(st[0]!='#' && p != NULL) {
	   	select_value(st,"UIDBASE", out);
	   	if(strcmp(out,"NULL")!=0) { 
				select_value(st, "DIR", out);
				 	if(strcmp(out,"NULL")!=0) {
						strcpy(uid32base, "DISK/");
						strcat(uid32base, out);
					}
			}
		}

		//IP serwera MYIP
		p = strstr(st, "IP_MYIP");
	   if(st[0]!='#' && p != NULL) {
			select_value(st,"IP_MYIP",out);
	   	if(strcmp(out,"NULL")!=0) strcpy(ipaddress, out);
		}

		//port serwera MYIP
		p = strstr(st, "PORT_MYIP");
	   if(st[0]!='#' && p != NULL) {
	   	select_value(st,"PORT_MYIP",out);
	   	if(strcmp(out,"NULL")!=0) port = atoi(out);
		}

		//IP serwera Centralnego UIDC
		p = strstr(st, "CENTRALSERVER");
	   if(st[0]!='#' && p != NULL) {
	   	select_value(st,"CENTRALSERVER",out);
	   	if(strcmp(out,"NULL")!=0) strcpy(central_ip, out);
		}

		//port serwera Centralnego UIDC
		p = strstr(st, "PORT_CENTRAL");
	   if(st[0]!='#' && p != NULL) {
			select_value(st, "PORT_CENTRAL", out);
	   	if(strcmp(out,"NULL")!=0) port_central = atoi(out);
	   }
	}
	fclose(fd);

	// --- parsowanie ---
	
	//sprawdza uid32base
	if(strcmp(uid32base, "null") == 0) {
		printf("\n\n  Error: incorrect path to varstat.q in %s\n\n", 
					CONFIG_FILENAME);
		return -1;
	}

	//sprawdza port 
	if(port == 0) {
		printf("\n\n  Error: incorrect port of MYIP server in %s\n\n", 
				CONFIG_FILENAME);
		return -1;
	}

	//sprawdza formalna poprawnosc adresu serwera MYIP
	ch=0;
	for(i=0; i<(int)strlen(ipaddress); i++) {
		if(*(ipaddress+i) == '.') ch++;
		if(*(ipaddress+i) != '.' && 
			*(ipaddress+i) < 48 &&
			*(ipaddress+i) >57) ch=10;//zawsze blad
	}
	if(ch != 3) {
		printf("\n\n  Error: incorrect IP of MYIP server in %s\n\n", 
				CONFIG_FILENAME);
		return -1; 	
	}

	//sprawdza porawnosc portu serwaera UIDC
	if(port_central == 0) {
		printf("\n\n  Error: incorrect port of server UIDC in %s\n\n", 
				CONFIG_FILENAME);
		return -1;
	}

	//sprawdza formalna poprawnosc adresu serwera UIDC
	ch=0;
	for(i=0; i<(int)strlen(central_ip); i++) {
		if(*(central_ip+i) == '.') ch++;
		if(*(central_ip+i) != '.' && 
			*(central_ip+i) < 48 &&
			*(central_ip+i) >57) ch=10;//zawsze blad
	}
	if(ch != 3) {
		printf("\n\n  Error: incorrect IP of server UIDC in %s\n\n", 
				 CONFIG_FILENAME);
		return -1; 	
	}

	return 0;
}
///////////////////////////////////////////////////////////////////////////////
//-------------------------- END CONFIG MYIPBase -------------------------------
///////////////////////////////////////////////////////////////////////////////





///////////////////////////////////////////////////////////////////////////////
//               TEST H00 SERVERA ORAZ WCZYTUJE DANE z pliku VARSTAT 
///////////////////////////////////////////////////////////////////////////////
//testuje obenosc serwera MYIP
int test_server_MYIP(void) {
	char reply[80];
	char *p;
	client_U_MYIP(ipaddress, port, "TEST=H00&", reply);
	p = strstr(reply, "mserverMYIP&");
	if( p != NULL ) return 1;
	return 0;
}


//sprawdza obecnosc serwera Centralnego UIDC
int test_server_UIDC(void) {
	char reply[80];
	char *p;
	client_U(central_ip, port_central, "TEST=H00&", reply);
	p = strstr(reply, "mserverUID_CENTRAL&");
	if( p != NULL ) return 1;
	return 0;
}


//wczytuje dane z pliku varstat.q (to moze sie zmieniac)
int read_varstat(int*vs) {

	char fn[PATH_SIZE];

	strcpy(fn, uid32base);
	strcat(fn, "/");
	strcat(fn, VARSTAT);

	FILE*fd = fopen(fn, "r");
	if(fd == NULL) return -1;
	fgets(fn, PATH_SIZE, fd);
	fclose(fd);
	
	//VARSTAT=static& lub VARSTAT=var&
	char *p = strstr(fn, "static");
	if(p != NULL) *vs = 0; //static
	else *vs = 1;

	return 0;	
}


//wczytuje UID32 z pliku .../UID32BASE/name w strukturze UIDL 
int read_uid32(char*uid) {

	char fname[128];

	strcpy(fname, uid32base);
	strcat(fname, "/name");

	FILE*fd = fopen(fname, "r");
	if(fd == NULL) {
		strcpy(uid, "null");

		return -1;
	}

	fgets(fname, 128, fd);
	fclose(fd);

	select_value(fname, "UID32", uid);
	if(strcmp(uid, "NULL") == 0) strcpy(uid, "null");
	return 0;
}
///////////////////////////////////////////////////////////////////////////////
// 	      END TEST H00 SERVERA ORAZ WCZYTUJE DANE z pliku VARSTAT
/////////////////////////////////////////////////////////////////////////////// 





///////////////////////////////////////////////////////////////////////////////
//                               MYIP CLIENT BODY
///////////////////////////////////////////////////////////////////////////////

//inicjalizacja procesu
int client_myip_init_ip(char*uid32) {

	char reply[128];
	char my_ip[20];
	char st[128];


	// --- sprawadza ustawienie flag oraz czy node ma nadany UID32 ---
	
	//sparawdza czy uid32 (UIDL) jest juz ustanowione
	if(strcmp(uid32, "null") == 0) { 
		if(read_uid32(uid32) < 0) return 0; //jesli daemon zgubi UID32
		if(strcmp(uid32, "null") == 0) return 0;
	}


	// --- pobieranie adresu IP (WAN) UIDL ---

	//sprawdza obecnosc serwera MYIP
	if(!test_server_MYIP()) return 0;

	//dzialanie MY IP (pobiera WAN IP dla serwera UIDL)
	if(client_U_MYIP(ipaddress, port, "OP=my_ip&", reply) < 0) return 0;	
	select_value(reply, "IP", my_ip);
	if(strcmp(my_ip, "NULL") == 0) {
			strcpy(my_ip, "null");
			return 0;
	}

	//spawdza czy nastapila zmiana IP (WAN) UIDL
	if(strcmp(my_ip, ip_UIDL) != 0) strcpy(ip_UIDL, my_ip);
	else return 0; //nie wysyala do UIDC jesli nie nastapila zmiana adresu UIDL


	// --- Wysyala dane do pliku ip.q (w UID32BASE) w UIDC ---

	//sprawdza obecnosc Serwera Centralnego UIDC
	if(!test_server_UIDC()) return 0;

	//wysyla adress IP serwera UIDL do serwera UIDC
	//OP=add_ip_node&UID32=..&IPNODE=..&
	//dla var (tzn. vs==1)
	strcpy(st, "OP=add_ip_node&UID32=");
	strcat(st, uid32);
	strcat(st, "&IPNODE=");
	strcat(st, my_ip);
	strcat(st, "&");


	//wysyla zmiane portu UIDL do ip.q w UID32BASE w UIDC 
	client_U(central_ip, port_central, st, reply);
	select_value(reply, "STATUS", st);
	if(strcmp(st, "refused") == 0) return 0;

	
	return 1;
}




//funkcja dla daemon dla obslugi przypadku var
int client_myip_var_ip(const char*uid) {

	int vs;
	char reply[128];
	char my_ip[20];
	char st[128];
	char uid32[35] = "null";

	strcpy(uid32, uid);

	// --- sprawadza ustawienie flag oraz czy node ma nadany UID32 ---
	
	//wczytuje z pliku varstat
	if(read_varstat(&vs) < 0) return 0; //brak pliku
	if(vs == 0) return 0; //jesli odczytuje z pliku flage statc (IP)

	//sparawdza czy uid32 (UIDL) jest juz ustanowione
	if(strcmp(uid32, "null") == 0) { 
		if(read_uid32(uid32) < 0) return 0; //jesli daemon zgubi UID32
		if(strcmp(uid32, "null") == 0) return 0;
	}


	// --- pobieranie adresu IP (WAN) UIDL ---

	//sprawdza obecnosc serwera MYIP
	//if(!test_server_MYIP()) return 0;

	//dzialanie MY IP (pobiera WAN IP dla serwera UIDL)
	if(client_U_MYIP(ipaddress, port, "OP=my_ip&", reply) < 0) return 0;	
	select_value(reply, "IP", my_ip);
	if(strcmp(my_ip, "NULL") == 0) {
			strcpy(my_ip, "null");
			return 0;
	}

	//spawdza czy nastapila zmiana IP (WAN) UIDL
	if(strcmp(my_ip, ip_UIDL) != 0) strcpy(ip_UIDL, my_ip);
	else return 0; //nie wysyala do UIDC jesli nie nastapila zmiana adresu UIDL


	// --- Wysyala dane do pliku ip.q (w UID32BASE) w UIDC ---

	//sprawdza obecnosc Serwera Centralnego UIDC
	if(!test_server_UIDC()) return 0;

	//wysyla adress IP serwera UIDL do serwera UIDC
	//OP=add_ip_node&UID32=..&IPNODE=..&
	//dla var (tzn. vs==1)
	strcpy(st, "OP=add_ip_node&UID32=");
	strcat(st, uid32);
	strcat(st, "&IPNODE=");
	strcat(st, my_ip);
	strcat(st, "&");

	//wysyla zmiane portu UIDL do ip.q w UID32BASE w UIDC 
	client_U(central_ip, port_central, st, reply);
	select_value(reply, "STATUS", st);
	if(strcmp(st, "refused") == 0) return 0;

	
	return 1;
}
///////////////////////////////////////////////////////////////////////////////            //                              MYIP CLIENT BODY
///////////////////////////////////////////////////////////////////////////////





void test_my_ip(void) {

	
	char reply[128];
	char my_ip[20];
	int small_delay;
	int n;

printf("IP: %s, PORT: %d\n", ipaddress,  port);

	n = 0;
	while( 1 ) {
			
		if(client_U_MYIP(ipaddress, port, "OP=my_ip_time&", reply) < 0) {
			printf("\n ... no connection to mserverMYIP ...\n");
			exit(0);
		}	
		//printf("REPLY: %s\n", reply);
		select_value(reply, "IP", my_ip);
		if(strcmp(my_ip, "NULL") == 0) {
			strcpy(my_ip, "null");
		}

		n ++;

		printf("Nr %d\t IP: %s\n", n, my_ip);

		small_delay = rand()%7;
		sleep( small_delay);
		}

}









int main() {

	int ret;
	int n, k;
	char uid32[35] = "null";
  	pid_t pid;
	
	int small_delay;



	//daje male opoznienie losowe
	srand(time(NULL));

	//wczytuje dane z mserverUIDL.config
	ret = read_config();
	if(ret < 0) return 0;

	printf("\n");
	printf("  MYIP address: %s\n", ipaddress);
 	printf("  MYIP port:    %d\n\n", port);

	//test
	test_my_ip(); return 0; //<----------------------------- test


	// --- incjalizacja i rejestruja w ip.q (UIDC) adress IP ---
	n = 0; k=1;
	while( strcmp(uid32, "null") == 0 ) {
			
		ret = client_myip_init_ip(uid32);
		
		if(ret == 0) {

			if(k) { 
				printf("\33[2K\r  wait for end of init: "); 
				fflush(stdout); 
				k=0;
			}

			printf("*"); fflush(stdout); n++;
		} 

		small_delay = rand()%7;
		sleep(DELAY_INIT + small_delay);
		if(n==10) {
			printf("\33[2K\r  wait for end of init: "); fflush(stdout);
			n=0;
		}
	}
	if(n != 0) {printf("\33[2K\r"); fflush(stdout);}
	// --- END incjalizacja i rejestruja w ip.q (UIDC) adress IP ---




  	printf("\n\n       --- Daemon MYIP ---\n\n");	



	//		---------- DAEMON ----------

  	// --- szkielet demona ---
 	pid = fork();
  	if(pid==-1) exit(EXIT_FAILURE);//return -1;
 	else 
  	if(pid!=0) exit(EXIT_SUCCESS);


  	//nowa sesja
  	if(setsid()==-1) return -1; 
  	//zmiana katalogu roboczego aby przy odmotowaniu HDD nie bylo problemu
  	if(chdir("/")==-1) return -1; 

  	//zamyka pliki
  	close(STDIN_FILENO);
  	close(STDOUT_FILENO);
  	close(STDERR_FILENO);
  	// --- Koniec szkieletu demona ---


 	//--- tresc daemona ---
	while(1) {
	
		small_delay = rand()%7 +  3;

		//jesli zadelratowany jest var (adres IP)
		client_myip_var_ip(uid32);
		
		sleep(DELAY_VAR + small_delay); //dodaje drobene opoznienienie losowe
	}
 	//--- koniec tresci daemona ---	
 

  return 0;
}
