///////////////////////////////////////////////////////////////////////////////
//
//                               ARCHI
//			              Funkcje dla executorMYIP.c
//			                    mserverMYIP.c
//                             (library)
//	                             ver 0.2
//                            (JPW - 2019)
//
//
///////////////////////////////////////////////////////////////////////////////



#include <stdio.h>
#include <string.h>
#include <time.h>
#ifndef SELECT 
#define SELECT
#include "SRC/select_value.c" 
#endif


#ifndef READ_CONFIG 
#define READ_CONFIG
#include "SRC/read_config.c"
#endif




///////////////////////////////////////////////////////////////////////////////
// ----------------------------- prototypy funkcji ----------------------------
///////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////
//--------------------------Koniec prototypow funkcji -------------------------
///////////////////////////////////////////////////////////////////////////////



//pobiera dokladny czas
int get_qtime(char*qtime) {

	struct timespec ts;
	int ret;
	char sec[80];
	char nsec[80];

	ret = clock_gettime( CLOCK_REALTIME, &ts);
	if(ret < 0) {
		strcpy(qtime, "SEC=null&NS=null&");
		return -1;
	}

	sprintf(sec,  "%ld", ts.tv_sec);
	sprintf(nsec, "%ld", ts.tv_nsec);

	strcpy(qtime, "SEC=");
	strcat(qtime, sec);
	strcat(qtime, "&NS=");
	strcat(qtime, nsec);
	strcat(qtime, "&");

	return 0;
}



//odsyla ip 
int my_ip(const char*ip_client, char*out) {

		int i;
	
		int ch = 0;
		for(i=0; i < (int)strlen(ip_client); i++) {
			if(*(ip_client+i) == '.') ch++;
		}
		if(ch != 3) {
			strcpy(out, "IP=null&"); 
			return -1;
		}

		strcpy(out, "IP=");
		strcat(out, ip_client);
		strcat(out, "&");
		
		return 1;
}




//odsyla ip oraz czas serwera
int my_ip_time(const char*ip_client, char*out) {

		int i;
		char qtime[80];
	
		int ch = 0;
		for(i=0; i < (int)strlen(ip_client); i++) {
			if(*(ip_client+i) == '.') ch++;
		}
		if(ch != 3) {
			strcpy(out, "IP=null&"); 
			return -1;
		}


		strcpy(out, "IP=");
		strcat(out, ip_client);
		strcat(out, "&");
		
		get_qtime(qtime); 
		strcat(out, qtime);

		return 1;

}




	//OP=versionMYIP&
	//RE=versionMYIP&VER=..&SYS=...&
	//lub
	//RE=versionMYIP&VER=null&SYS=null&CP=<powod bledu>&
int versionMYIP(const char*in, char*out) {

	char st[128];
	char *p;

	FILE*fd = fopen("BIN/version", "r");
	if(fd == NULL) {
		strcpy(out, "RE=versionMYIP&VER=null&SYS=null&CP=no_file&");
		return -1;
	}

	fgets(st, 128, fd);
		p = strchr(st, '\n');
		if(p != NULL) *p = '\0';
		strcpy(out, "RE=versionMYIP&VER=");
		strcat(out, st);
		strcat(out, "&SYS=");
		fgets(st, 128, fd);
	fclose(fd);

		p = strchr(st, '\n');
		if(p != NULL) *p = '\0';
		strcat(out, st);
		strcat(out, "&");
	return 0; 
}




/*
int main() {

char out[80];
int ret = get_qtime(out);

char ip_client[80] = "171.15.10.201";


ret = my_ip_time(ip_client, out);

ret = my_ip(ip_client, out);

printf("QTIME: %s\n", out);
printf("RET:   %d\n", ret);

return 0;
} 
*/
